﻿// Damge over time cooldown
// Amount of frames it takes to deal the next portion of damage
var nFireTime:Number = 100;
// Amount of skills each Player Character posses
// In case of enemies, they can use as much skills as they have animations for.
// That is, if enemy have 9 frames of animations (with 9 frame being the "skill1" frame) it will use one skill
// Enemy with 13 frames will have frame 9("skill1"), frame 10("skill2"), frame 11("skill3"), frame 12("skill4") and frame 13("skill5");
// thus using 5 difrent skills.
var nSkillsNumber:Number=3;
// Miss Factor
// A number between -1.0 and 1.0
// Always miss			No change 				Always hit
// -1.0 ............... 0.0 ................... 1.0
var nMissFactor:Number=0.3;

//allows "Run" options in a battle
//It is double-edged as it will also allow running for the enemies
if(allowBattleRun==null) var allowBattleRun:Boolean = true;

/* =================================================================
KamiBattleStatus.as ------------------------------------------------
*/

// Stuff to do when quitting a fight (if player won)
var fightExitWon:Function = function ():Void {
	_root.displayStatus(_root.showBack[0]);
	_root.displayItems(_root.showBack[1]);
	_root.displayEquip(_root.showBack[2]);
	_root.displayIcons(_root.showBack[3]);
	_root.displayPlayer(true);
	_root.displayPotions(true);
	_root.displayFollower(true);
	_root.allowSave = true;
	_root.scrollEffect = _root.showBack[4];
	_root.blackMap = _root.showBack[5];
	_root.enableKeyListener();
	_root.disableBattleListener();
	_root.fightReturn();
}
// Stuff to do when quitting a fight (if player lost)
var fightExitLost:Function = function ():Void {
	_root.displayStatus(_root.showBack[0]);
	_root.displayItems(_root.showBack[1]);
	_root.displayEquip(_root.showBack[2]);
	_root.displayIcons(_root.showBack[3]);
	_root.displayPlayer(true);
	_root.displayPotions(true);
	_root.displayFollower(true);
	_root.allowSave = true;
	_root.aLights = new Array();
	_root.setPlayerPos(250,250);
	_root.scrollEffect = _root.showBack[4];
	_root.enableKeyListener();
	_root.disableBattleListener();
	_root.fightReturn(_root.deadFrame);
}