﻿//Kamineko Battle Interface Setup
/*
if (_root.BInter == null) {
	throw new Error("== ERROR ==\n\"BInter\" MovieClip not found on the main timeline's battle frame");
}
*/
if (_root.BInter == null) {
	_root.createEmptyMovieClip("BInter",_root.getNextHighestDepth());
	var bBattleInterCreated:Boolean = true;
} else if(!bBattleInterCreated) {
	if(_root.kbtt!=null) _root.kbtt=null;
	if(_root.kbuSum!=null) _root.kbuSum=null;
	if(_root.kbcCommand!=null) _root.kbcCommand=null;
	if(_root.kbsStat!=null) _root.kbsStat=null;
}
_root.BInter._visible = true;

var cBInterColor:Color = new Color(_root.BInter);
_root.cBInterColor.setTransform(_root.trans2);
/*Kamineko Level Up Window ====================================================
This is a pop-up window that is displayed whenever one of the party members levels up.

*/
#include "KamiBattleLVLUP.as"
//
/*Kamineko Chat Window ========================================================
Aka Battle Status Window.
Shows comments about the battle.

Contains Main Loop of the battle engine.

Will call _root.fightExitWon() if Player defeats all his opponents
Will call _root.fightExitLost() if Player lose all his Party members
*/
#include "KamiBattleStatusWindow.as"
//
/* Kamineko Commands Window ===================================================
Ataches "Battle_Commands" MovieClip.
Expects following MovieClips inside:
"mcAtt" - MovieClip of Attack button
"mcDef" - MovieClip of Defend button
"mcRun" - MovieClip of Run Away button
"mcSum" - MovieClip of Summon button

Will look for MovieClips with names "mcSkill"+number. For Example:
"mcSkill1" - MovieClip of Skill 1 button
"mcSkill2" - MovieClip of Skill 2 button
"mcSkill3" - MovieClip of Skill 3 button
...
Stops when there are no more MovieClips matching above pattern
or when number of found MovieClips is equal to number of skills (_root.nSkillsNumber);

And also will look for MovieClips with names "mcHP"+number and "mcMP"+number. For Example:
"mcHP1" - MovieClip of Health Potion Small button
"mcHP2" - MovieClip of Health Potion Big button
...
"mcMP1" - MovieClip of Mana Potion Small button
"mcMP2" - MovieClip of Mana Potion Big button
...
MovieClips of Potion are expected to have TextField named "tfAmount"

NOTE: Commands Window will not be positioned. It shows at (0,0). Design it accordingly.
NOTE2: Will call _root.chooseCommand() included in KamiBattleChars.as
*/
#include "KamiBattleCommands.as"

/* Kamineko ToolTip ==========================================================
Creates a ToolTip window.
After a delay (20 frames) shows the description.

_root.showToolTip(s:String):Void
	Shows the ToolTip.
	s - message to display;
_root.hideToolTip():Void
	Hides the ToolTip.
*/
#include "KamiBattleTips.as"

// You can create your own help screen instead of having it attached
if(_root.BInter.FAQ == null) _root.BInter.attachMovie("FAQ", "FAQ", _root.BInter.getNextHighestDepth());
_root.BInter.FAQ.gotoAndStop(2);
_root.BInter.FAQ._visible=false;
_root.BInter.FAQ._x = (_root.swidth/2)-(_root.BInter.FAQ._width/2);
_root.BInter.FAQ._y = ((_root.sheight/2)-(_root.BInter.FAQ._height/2))+30;

/*
// DEPRECATED =========================================================================
// Following scripts were created to include the possiblity of extending number of skills
// in later production.
// However, the final effect is nicer and easier if you limit the number of skills and
// build your Battle Interface around that fact.
// ------------------------------------------------------------------------------------
//Kamineko Choosing Menu ==============================================================
It is somewhat a grouping MovieClip that holdes MCs that are only showen when Player choose next move.
Name can be misleading, but at beginning it was just supposed to be grouping window for Choosing Buttons (see below).

It holdes:
-Attack, Defend, Run, Summon Buttons
-Hint Window
-Skills Buttons

mc = _root.BInter.createEmptyMovieClip("ChoMenu", _root.BInter.getNextHighestDepth());
mc._x = 10;
mc._y = _root.BInter.stat._y;
mc._visible = false;
//
//Kamineko Hint Window =========================================================
This window shows a short description of choosen button.


//#include "KamiBattleHint.as"
//
//Kamineko Choosing Buttons ====================================================
4 Buttons: Attack, Defend, Run and Summon

//#include "KamiBattleChoose.as"
//
//Kamineko Skills Menu =========================================================
A MovieClip with Linkage 'Battle_Skill' is used here.
By default: 3 buttons per row.

//#include "KamiBattleSkills.as"
*/