﻿var showFollower:Boolean = false;

if(_root.FollowerInstance==null) throw new Error("== ERROR ==\n\"FollowerInstance\" MovieClip not found on the main timeline!");
_root.fDepth = _root.FollowerInstance.getDepth();
var addFollower:Function = function(mc:MovieClip):Boolean  {
	if(_root.Follower.isFollowing) {
		_root.SMS("You can do only one \"Lead the way\" quest at the same time",60);
		return false;
	}
	mc.swapDepths(_root.getNextHighestDepth());
	mc.isFollowing = true;
	_root.Follower = mc;
	mc.onEnterFrame = function():Void  {
		//trace(""+this.getDepth()+" | "+_root.fDepth);
		if (this.getDepth()>_root.fDepth) {
			_root.createEmptyMovieClip("Followers",_root.fDepth);
			this.swapDepths(_root.fDepth);
		}
		//trace(""+_root.Followers._x+" : "+_root.Followers._y+" - "+this._visible);    
		if (_root.showFollower) {
			//Char movement
			if (_root.worldMap>-1) {
				this._visible = false;
			} else {
				this._visible = true;
				this.gotoAndStop(this.dir);
			}
			if (!this.hitTest(_root.Player)) {
				//var a:Number = Math.atan2(_root.Followers[this.tar]._y-this._y, _root.Followers[this.tar]._x-this._x);
				var a:Number = Math.atan2(_root.Player._y-this._y, _root.Player._x-this._x);
				var tc:Number = Math.cos(a)*_root.speed;
				var ts:Number = Math.sin(a)*_root.speed;
				this._x += tc;
				this._y += ts;
				if (Math.abs(tc)>Math.abs(ts)) {
					if (tc>0) {
						this.dir = 4;
					} else {
						this.dir = 2;
					}
				} else {
					if (ts>0) {
						this.dir = 3;
					} else {
						this.dir = 1;
					}
				}
			}
		}
	};
	mc.swapDepths(_root.fDepth);
	_root.showFollower = true;
	return true;
};
var removeFollower:Function = function():Void  {
	_root.Follower.isFollowing = false;
	_root.removeMovie(_root.Follower);
	_root.Follower=null;
	_root.Followers.swapDepths(_root.fDepth);
};
var displayFollower:Function = function(b:Boolean):Void {
	_root.Follower._visible = b;
	_root.showFollower = b;
}
var resetFollower:Function = function(nx:Number,ny:Number):Void {
	if (_root.Follower._name != null && _root.Follower._name != undefined) {
			_root.Follower.swapDepths(_root.getNextHighestDepth());
	}
	if(nx!=null) _root.Follower._x = nx;
	if(ny!=null) _root.Follower._y = ny;
}
