﻿var sndVol:Number = 100;
// Sounds array -----------------------------------------------------
var nLastLoaded:Number = 0;
var nLastLoadedLoop:Number = 0;
var sLastPlayed:String = null;
var nTimePlayed:Number = 0;
// All sounds are created in this array to simplify memory managment
var SND:Array = new Array();
var mcGlobalControl:MovieClip = _root.createEmptyMovieClip("GlobalSoundControler",_root.getNextHighestDepth());;
var playSound:Function = function (n:String, b:Boolean, l:Number):Void {
	//
	var i:Number = 0;
	if (l>=0 || l == null) {
		for (i=0; i<_root.SND.length; i++) {
			if (_root.SND[i][0] == n && _root.SND[i][2]!=0 && _root.SND[i][2]!=null ) {
				return;
			}
		}
		for (i=0; i<=_root.SND.length; i++) {
			if (_root.SND[i][1] == null || ( _root.SND[i][1].duration == _root.SND[i][1].position && (_root.SND[i][2]==0 || _root.SND[i][2]==null)) ) {
				//_root.SND[i][1].stop();
				if(_root.sLastPlayed == n && getTimer()-_root.nTimePlayed<200) return;
				_root.sLastPlayed = n;
				_root.nTimePlayed = getTimer();
				_root.SND[i] = new Array(n, new Sound( _root.mcGlobalControl ), l);
				//First, trying to attach the sound from the library
				_root.SND[i][1].attachSound("snd_"+n);
				if (b) {
					/*
					Mono: 
 					ll = 100
					lr = 100
					rr = 0	
					rl = 0
					*/
					var tPan:Number = Math.cos(Math.random()*Math.PI)*100;
					_root.SND[i][1].setTransform( {ll:tPan,lr:100-tPan,rr:0,rl:0} );
				} else {
					_root.SND[i][1].setTransform( {ll:100,lr:100,rr:100,rl:100} );
				}
				_root.SND[i][1].setVolume(_root.sndVol);
				//
				if (_root.SND[i][1].position == null) {
					//Attach has failed
					//Trying to load the sound from the Sound driectory
					_root.SND[i][1].loadSound("Sound/"+n+".mp3", true);
					_root.SND[i][1].onLoad = _root.commonOnLoadEvent;
					_root.nLastLoaded = i;
					_root.nLastLoadedLoop = l;
				} else {
					_root.SND[i][1].start(0, l);
				}
				
				break;
			}
		}
	} else {
		
		for(var snd in _root.SND) {
			if (_root.SND[snd][0] == n) {
				_root.SND[snd][1].stop();
				_root.SND[snd] = null;
			}
		}
		
	}
};
var commonOnLoadEvent:Function = function (b:Boolean):Void {
	if (b) {
		_root.SND[_root.nLastLoaded][1].start(0, _root.nLastLoadedLoop);
	}
};
var resetSounds:Function = function():Void {
	for(var snd in _root.SND) {
		_root.SND[snd][1].stop();
		_root.SND[snd] = null;
	}
}
