﻿class classes.KamiBattleCommand {

	var mcComm:MovieClip = null;
	var aSkills:Array = null;
	var aPotionsH:Array = null;
	var aPotionsM:Array = null;
	var i:Number = 0;

	function KamiBattleCommand() {

		this.mcComm = _root.BInter.attachMovie("Battle_Commands", "CommMenu", _root.BInter.getNextHighestDepth());
		this.mcComm.gotoAndStop(1);
		this.mcComm._visible = false;

		// Attack
		this.mcComm.mcAtt.onRollOver = function():Void  {
			_root.showToolTip("Default Attack\n(SPACE Key)");
			this.gotoAndPlay(2);
		};
		this.mcComm.mcAtt.onRollOut = function():Void  {
			_root.hideToolTip();
			this.gotoAndPlay(4);
		};
		this.mcComm.mcAtt.onPress = function():Void  {
			_root.hideToolTip();
			this.gotoAndStop(1);
			_root.showCommandMenu(false);
			_root.chooseCommand(1);
		};
		// Defend
		this.mcComm.mcDef.onRollOver = function():Void  {
			_root.showToolTip("Defend\nHalfs damage and restores some Health and Mana.\nAffected by Character's Level.");
			this.gotoAndPlay(2);
		};
		this.mcComm.mcDef.onRollOut = function():Void  {
			_root.hideToolTip();
			this.gotoAndPlay(4);
		};
		this.mcComm.mcDef.onPress = function():Void  {
			_root.hideToolTip();
			this.gotoAndStop(1);
			_root.showCommandMenu(false);
			_root.chooseCommand(2);
		};
		// Run Away
		this.mcComm.mcRun.onRollOver = function():Void  {
			_root.showToolTip("Run Away\nYou got NO Experience points or Cash.\nMay not succeed.");
			this.gotoAndPlay(2);
		};
		this.mcComm.mcRun.onRollOut = function():Void  {
			_root.hideToolTip();
			this.gotoAndPlay(4);
		};
		this.mcComm.mcRun.onPress = function():Void  {
			if (this._alpha == 100) {
				this.gotoAndStop(1);
				_root.hideToolTip();
				_root.showCommandMenu(false);
				_root.chooseCommand(5);
			} else {
				_root.SMS("There's no where to run!",60);
			}
		};
		// Summon
		this.mcComm.mcSum.onRollOver = function():Void  {
			_root.showToolTip("Summon\nCalls for help from a powerful ally.");
			this.gotoAndPlay(2);
		};
		this.mcComm.mcSum.onRollOut = function():Void  {
			_root.hideToolTip();
			this.gotoAndPlay(4);
		};
		this.mcComm.mcSum.onPress = function():Void  {
			if (this._alpha == 100) {
				_root.hideToolTip();
				_root.chooseCommand(6);
				this.gotoAndStop(1);
			} else {
				_root.SMS("No Summon is available!",60);
			}
		};
		//
		// Skills
		this.aSkills = new Array();
		for (i=1; i<=_root.nSkillsNumber; i++) {
			if (this.mcComm["mcSkill"+i] != null) {
				this.aSkills.push(new Array(this.mcComm["mcSkill"+i]));
				this.aSkills[i-1][0].sid = i-1;
				this.aSkills[i-1][0].onPress = function():Void  {
					if (this._alpha == 100) {
						_root.hideToolTip();
						this._xscale = 100;
						this._yscale = 100;
						_root.showCommandMenu(false);
						_root.kbcCommand.doSkill(this.sid);
					} else {
						_root.SMS("You didn't learn that skill yet.",60);
					}
				};
				this.aSkills[i-1][0].onRollOver = function():Void  {
					this._xscale = 110;
					this._yscale = 110;
					_root.kbcCommand.showSkillTip(this.sid);
				};
				this.aSkills[i-1][0].onRollOut = function():Void  {
					this._xscale = 100;
					this._yscale = 100;
					_root.hideToolTip();
					this.play();
				};
			}
		}
		//
		// Potions
		this.aPotionsH = new Array();
		for (i=0; i<_root.heal.length; i++) {
			if (this.mcComm["mcHP"+(i+1)] != null) {
				this.aPotionsH.push(new Array(this.mcComm["mcHP"+(i+1)], null));
				this.aPotionsH[i][0].pid = i;
				this.aPotionsH[i][0].tfAmount.text = _root.heal[i][0];
				if(_root.heal[i][0]<=0 ) {
					_root.heal[i][0] = 0;
					this.aPotionsH[i][0]._alpha = 75;
				} else {
					this.aPotionsH[i][0]._alpha = 100;
				}
				this.aPotionsH[i][0].onPress = function():Void  {
					if (this._alpha == 100) {
						_root.hideToolTip();
						this._xscale = 100;
						this._yscale = 100;
						_root.showCommandMenu(false);
						_root.kbcCommand.doHeal(this.pid);
					}else {
						_root.SMS("You dont have any Healing Potions.",60);
					}
				};
				this.aPotionsH[i][0].onRollOver = function():Void  {
					this._xscale = 110;
					this._yscale = 110;
					_root.kbcCommand.showHealTip(this.pid);
				};
				this.aPotionsH[i][0].onRollOut = function():Void  {
					this._xscale = 100;
					this._yscale = 100;
					_root.hideToolTip();
					this.play();
				};
			}
		}
		this.aPotionsM = new Array();
		for (i=0; i<_root.mana.length; i++) {
			if (this.mcComm["mcMP"+(i+1)] != null) {
				this.aPotionsM.push(new Array(this.mcComm["mcMP"+(i+1)]));
				this.aPotionsM[i][0].pid = i;
				this.aPotionsM[i][0].tfAmount.text = _root.mana[i][0];
				if(_root.mana[i][0]<=0 ) {
					_root.mana[i][0] = 0;
					this.aPotionsM[i][0]._alpha = 75;
				} else {
					this.aPotionsM[i][0]._alpha = 100;
				}
				this.aPotionsM[i][0].onPress = function():Void  {
					if (this._alpha == 100) {
						_root.hideToolTip();
						this._xscale = 100;
						this._yscale = 100;
						_root.showCommandMenu(false);
						_root.kbcCommand.doMana(this.pid);
					}else {
						_root.SMS("You dont have any Mana Potions.",60);
					}
				};
				this.aPotionsM[i][0].onRollOver = function():Void  {
					this._xscale = 110;
					this._yscale = 110;
					_root.kbcCommand.showManaTip(this.pid);
				};
				this.aPotionsM[i][0].onRollOut = function():Void  {
					this._xscale = 100;
					this._yscale = 100;
					_root.hideToolTip();
					this.play();
				};
			}
		}
	}
	//
	public function doSkill(n:Number):Void {
		_root.chooseCommand(9+n);
	}
	public function showSkillTip(n:Number):Void {
		_root.showToolTip(this.aSkills[n][1]);
	}
	public function doHeal(n:Number):Void {
		_root.sendCommandHeal(n);
		this.aPotionsH[n][0].tfAmount.text = _root.heal[n][0];
		if(_root.heal[n][0]<=0 ) {
			_root.heal[n][0] = 0;
			this.aPotionsH[n][0]._alpha = 75;
		} else {
			this.aPotionsH[n][0]._alpha = 100;
		}
			
	}
	public function showHealTip(n:Number):Void {
		_root.showToolTip("Healing Potion (+"+_root.heal[n][1]);
	}
	public function doMana(n:Number):Void {
		_root.sendCommandMana(n);
		this.aPotionsM[n][0].tfAmount.text = _root.mana[n][0];
		if(_root.mana[n][0]<=0 ) {
			_root.mana[n][0] = 0;
			this.aPotionsM[n][0]._alpha = 75;
		} else {
			this.aPotionsM[n][0]._alpha = 100;
		}
	}
	public function showManaTip(n:Number):Void {
		_root.showToolTip("Mana Potion (+"+_root.mana[n][1]);
	}
	public function checkRun():Void {
		if(!_root.allowBattleRun) {
			this.mcComm.mcRun._alpha = 75;
		} else {
			this.mcComm.mcRun._alpha = 100;
		}
	}
	//
	public function setSkill(sid:Number, v:Boolean, skill:Array):Void {
		//0.name 1.picture 2.type 3.dmg 4.maxDMG 5.target 6.cost 7.unlocked 8.description
		if(v) {
			this.aSkills[sid][0]._visible = true;
			this.aSkills[sid][0].gotoAndStop(skill[1]+1);
			this.aSkills[sid][1] = skill[8]+"\n(MP cost: "+skill[6]+")";
			this.aSkills[sid][0].tfID.text = sid+1;
			this.aSkills[sid][0]._alpha = 100;
		} else {
			this.aSkills[sid][0]._visible = true;
			this.aSkills[sid][0]._alpha = 75;
			this.aSkills[sid][0].gotoAndStop(1);
			this.aSkills[sid][1] = "LOCKED";
			this.aSkills[sid][0].tfID.text = sid+1;
		}
	}
	public function setCommand(id:Number, n:Number):Void {
		switch (id) {
			case 1 :
				this.mcComm.mcAtt._alpha = n;
				break;
			case 2 :
				this.mcComm.mcDef._alpha = n;
				break;
			case 3 :
				this.mcComm.mcRun._alpha = n;
				break;
			case 4 :
				this.mcComm.mcSum._alpha = n;
				break;
		}
	}
	//
	public function isVisible():Boolean {
		return this.mcComm._visible;
	}
	public function setVisible(b:Boolean):Void {
		this.mcComm._visible = b;
	}
}