﻿class classes.KamiBattleToolTip {
	
	var mcTip:MovieClip;
	var tfTip:TextField;
	var nDelay:Number;
	var bShow:Boolean;
	
	function KamiBattleToolTip() {
		this.nDelay = 0;
		this.bShow = false;
		
		this.mcTip = _root.BInter.createEmptyMovieClip( "mcToolTip", _root.BInter.getNextHighestDepth() );
		this.mcTip._visible = false;
		this.mcTip.onEnterFrame = function():Void {
			_root.kbttTip.process();
		};
			
		this.tfTip = this.mcTip.createTextField( "tfTipText", this.mcTip.getNextHighestDepth(),0,0,1,1 );
		trace(this.tfTip._visible);
		this.tfTip.autoSize = true;
		this.tfTip.multiline = true;
		this.tfTip.selectable = false;
		this.tfTip.background = true;
		this.tfTip.backgroundColor = 0xff0000;
		this.tfTip.border = true;
		this.tfTip.borderColor = 0xffff00;
		this.tfTip.multiline = true;
		this.tfTip.wordWrap = false;
		this.tfTip.embedFonts = true;
		this.tfTip.setTextFormat(_root.format);
		this.tfTip.setNewTextFormat(_root.format);
			
	}
	
	public function process():Void {
		
		if(!this.bShow) return;
		
		if(this.nDelay>0) this.nDelay--;
		else {
			this.mcTip._visible = true;
			this.mcTip._x = _root.BInter._xmouse+5;
			this.mcTip._y = _root.BInter._ymouse-this.tfTip._height-5;
		}
	}
	
	public function showTip(s:String):Void {
		this.nDelay = 5;
		this.bShow = true;
		this.tfTip.text = s;
	}
	public function hideTip():Void {
		this.bShow = false;
		this.mcTip._visible = false;
	}
		
		
}