﻿class classes.KamiIcon {
	private var mcIcon:MovieClip;
	private var mcControl:MovieClip;
	private var mcBarHP:MovieClip;
	private var mcBarSP:MovieClip;
	private var mcBarEP:MovieClip;
	private var tfTextHP:TextField;
	private var tfTextSP:TextField;
	private var tfTextEP:TextField;
	//
	private var aChar:Array;
	private var cColor:Color;
	private var oTrans:Object;
	//
	private var nID:Number;
	private var nHP:Number;
	private var nSP:Number;
	private var nEP:Number;
	private var temp:Number;
	//
	private var bWarn:Boolean;
	private var bUp:Boolean;
	//
	function KamiIcon(id:Number) {
		if (_root.Inter["fac"+id] == null) {
			_root.Inter.attachMovie("statusAvatar", "fac"+id, _root.Inter.getNextHighestDepth());
		}
		this.mcIcon = _root.Inter["fac"+id];
		this.mcIcon._visible = false;
		this.mcIcon._x = 4+(((_root.swidth-4)/_root.playersCount)*(id-1));
		this.mcIcon._y = 5;
		this.aChar = _root.aPlayerTeam[id][0];
		this.nID = id;
		this.mcIcon.id = id-1;
		//
		this.nHP = -1;
		this.nSP = -1;
		this.nEP = -1;
		_root.format.size = 10;
		_root.format.bold = false;
		// HP Bar 
		if (this.mcIcon.barHP == null) {
			this.mcIcon.createEmptyMovieClip("barHP", this.mcIcon.getNextHighestDepth());
		}
		this.mcBarHP = this.mcIcon.barHP;
		//HP TEXT     
		if (this.mcIcon.textHP == null) {
			this.mcIcon.createTextField("textHP", this.mcIcon.getNextHighestDepth(), 100, 8, 60, 25);
		}
		this.tfTextHP = this.mcIcon.textHP;
		this.tfTextHP.selectable = false;
		this.tfTextHP.embedFonts = true;
		this.tfTextHP.setNewTextFormat(_root.format);
		this.tfTextHP.text = ""+this.aChar[5]+"/"+this.aChar[6];
		// SP Bar 
		if (this.mcIcon.barSP == null) {
			this.mcIcon.createEmptyMovieClip("barSP", this.mcIcon.getNextHighestDepth());
		}
		this.mcBarSP = this.mcIcon.barSP;
		//SP TEXT      
		if (this.mcIcon.textSP == null) {
			this.mcIcon.createTextField("textSP", this.mcIcon.getNextHighestDepth(), 110, 21, 60, 20);
		}
		this.tfTextSP = this.mcIcon.textSP;
		this.tfTextSP.selectable = false;
		this.tfTextSP.embedFonts = true;
		this.tfTextSP.setNewTextFormat(_root.format);
		this.tfTextSP.text = ""+this.aChar[7]+"/"+this.aChar[8];
		// EP Bar 
		if (this.mcIcon.barEP == null) {
			this.mcIcon.createEmptyMovieClip("barEP", this.mcIcon.getNextHighestDepth());
		}
		this.mcBarEP = this.mcIcon.barEP;
		//EXP TEXT      
		if (this.mcIcon.textEP == null) {
			this.mcIcon.createTextField("textEP", this.mcIcon.getNextHighestDepth(), 120, 35, 60, 20);
		}
		this.tfTextEP = this.mcIcon.textEP;
		this.tfTextEP.selectable = false;
		this.tfTextEP.embedFonts = true;
		this.tfTextEP.setNewTextFormat(_root.format);
		this.tfTextEP.text = ""+this.aChar[9]+"/"+this.aChar[10];
		//
		_root.format.size = 11;
		_root.format.bold = true;
		//Controller
		if (_root.Inter["c_type"+id] == null) {
			_root.Inter.attachMovie("Control_Type", "c_type"+id, _root.Inter.getNextHighestDepth());
		}
		this.mcControl.id = id-1;
		this.mcControl = _root.Inter["c_type"+id];
		this.mcControl._visible = false;
		this.mcControl._x = this.mcIcon._x+7;
		this.mcControl._y = this.mcIcon._y+this.mcIcon._height-5;
		if (this.aChar[15]) {
			this.mcControl.gotoAndStop(2);
		} else {
			this.mcControl.gotoAndStop(1);
		}
		//Color Warning
		this.cColor = new Color(this.mcIcon);
		this.oTrans = this.cColor.getTransform();
		//
		// Listeners
		this.mcIcon.onPress = function():Void  {
			_root.charSelect = this.id+1;
			//this.gotoAndStop(_root.aPlayerTeam[_root.charSelect][0][0]);
			_root.changePlayerAvatar(_root.aPlayerTeam[_root.charSelect][0][0]);
			_root.refreshHUD();
		};
		this.mcControl.onPress = function():Void  {
			_root.aIcons[this.id].changeControl();
		};
		//
		//Main Loop
		this.mcIcon.onEnterFrame = function():Void  {
			_root.aIcons[this.id].process();
		};
	}
	public function process():Void {
		//Main part
		if (_root.showIcons && this.aChar != null) {
			this.mcIcon._visible = true;
			this.mcControl._visible = true;
			if (this.bWarn) {
				if (!this.bUp) {
					this.oTrans.rb+=10;
					if (this.oTrans.rb>100) {
						this.bUp = true;
					}
				} else {
					this.oTrans.rb-=10;
					if (this.oTrans.rb<=0) {
						this.bUp = false;
					}
				}
				this.cColor.setTransform(this.oTrans);
			}
			//HP Bar    
			if (this.nHP != this.aChar[5]) {
				this.mcBarHP.clear();
				this.temp = 60+((this.aChar[5]/this.aChar[6])*90);
				this.mcBarHP.beginFill(0xff0000, 100);
				this.mcBarHP.moveTo(60, 18);
				this.mcBarHP.lineTo(this.temp, 18);
				this.mcBarHP.lineTo(this.temp, 28);
				this.mcBarHP.lineTo(60, 28);
				this.mcBarHP.endFill();
				this.mcBarHP.beginFill(0xff0000, 50);
				this.mcBarHP.moveTo(this.temp, 18);
				this.mcBarHP.lineTo(150, 18);
				this.mcBarHP.lineTo(150, 28);
				this.mcBarHP.lineTo(this.temp, 28);
				this.mcBarHP.endFill();
				//HP TEXT 
				this.tfTextHP.text = ""+this.aChar[5]+"/"+this.aChar[6];
				this.nHP = this.aChar[5];
				//HP warning
				if (this.nHP<this.aChar[6]/4) {
					this.bWarn = true;
				} else {
					this.bWarn = false;
					this.oTrans.rb = 0;
					this.cColor.setTransform(this.oTrans);
				}
			}
			//SP Bar          
			if (this.nSP != this.aChar[7]) {
				this.mcBarSP.clear();
				this.temp = 65+((this.aChar[7]/this.aChar[8])*90);
				this.mcBarSP.beginFill(0x0000ff, 100);
				this.mcBarSP.moveTo(65, 31);
				this.mcBarSP.lineTo(this.temp, 31);
				this.mcBarSP.lineTo(this.temp, 41);
				this.mcBarSP.lineTo(65, 41);
				this.mcBarSP.endFill();
				this.mcBarSP.beginFill(0x0000ff, 50);
				this.mcBarSP.moveTo(this.temp, 31);
				this.mcBarSP.lineTo(155, 31);
				this.mcBarSP.lineTo(155, 41);
				this.mcBarSP.lineTo(this.temp, 41);
				this.mcBarSP.endFill();
				//SP TEXT
				this.tfTextSP.text = ""+this.aChar[7]+"/"+this.aChar[8];
				this.nSP = this.aChar[7];
			}
			//EP Bar         
			if (this.nEP != this.aChar[9]) {
				this.mcBarEP.clear();
				this.temp = 70+((this.aChar[9]/this.aChar[10])*90);
				if (this.temp>160) {
					this.temp = 160;
				}
				this.mcBarEP.beginFill(0xffff00, 100);
				this.mcBarEP.moveTo(70, 45);
				this.mcBarEP.lineTo(this.temp, 45);
				this.mcBarEP.lineTo(this.temp, 55);
				this.mcBarEP.lineTo(70, 55);
				this.mcBarEP.endFill();
				this.mcBarEP.beginFill(0xffff00, 50);
				this.mcBarEP.moveTo(this.temp, 45);
				this.mcBarEP.lineTo(160, 45);
				this.mcBarEP.lineTo(160, 55);
				this.mcBarEP.lineTo(this.temp, 55);
				this.mcBarEP.endFill();
				//EXP TEXT
				this.tfTextEP.text = ""+this.aChar[9]+"/"+this.aChar[10];
				this.nEP = this.aChar[9];
			}
		} else {
			this.mcIcon._visible = false;
			this.mcControl._visible = false;
		}
	}
	public function changeControl():Void {
		this.aChar[15] = !this.aChar[15];
		if (this.aChar[15]) {
			this.mcControl.gotoAndStop(2);
		} else {
			this.mcControl.gotoAndStop(1);
		}
	}
	public function doRefresh(id:Number):Void {
		this.aChar = _root.aPlayerTeam[id][0];
		if (this.aChar == null) {
			this.mcIcon._visible = false;
			this.mcControl._visible = false;
		} else {
			this.mcIcon.id = this.nID-1;
			this.mcControl.id = this.nID-1;
			//fade
			if (_root.charSelect == this.nID) {
				this.oTrans.aa = 100;
			} else {
				this.oTrans.aa = 75;
			}
			//Control
			if (this.aChar[15]) {
				this.mcControl.gotoAndStop(2);
			} else {
				this.mcControl.gotoAndStop(1);
			}
			//REFREASHING
			//Avatar chooser
			if (this.aChar != null) {
				this.mcIcon.gotoAndStop(this.aChar[12]);
			}
			// HP and SP recalculation      
			this.aChar[6] = this.aChar[2]*10;
			this.aChar[8] = this.aChar[4]*5;
			this.nHP = -1;
			this.nSP = -1;
			this.nEP = -1;
		}
	}
}
