﻿class classes.KamiObject {
	private var minX:Number = null;
	private var maxX:Number = null;
	private var minY:Number = null;
	private var maxY:Number = null;
	private var swapPoint:Number = null;
	private var oDepth:Number = null;
	private var lDepth:Number = null;
	private var mcObject:MovieClip = null;
	private var tx:Number = null;
	private var ty:Number = null;
	private var bTouch:Boolean = null;
	private var bbBound:Object = null;
	// On Space key press event
	public var onSpace:Function = null;
	public var onTouch:Function = null;
	// Constructor
	public function KamiObject() {
		_root.aKamiObjects[_root.aKamiObjects.length] = this;
	}
	// Attaches a given MovieClip to a KamiObject
	public function attach(tar:MovieClip, minx:Number, maxx:Number, miny:Number, maxy:Number, sp:Number):Void {
		this.mcObject = tar;
		//this.bbBound = tar.getBounds(tar);
		//this.sw = this.bbBound.xMin;
		this.bbBound = tar.getBounds(_root);
		//BORDERS
		if (minx == null) {
			this.minX = -5;
		} else {
			this.minX = minx;
		}
		if (maxx == null) {
			this.maxX = tar._width+5;
		} else {
			this.maxX = maxx;
		}
		if (miny == null) {
			this.minY = tar._height/2;
		} else {
			this.minY = miny;
		}
		if (maxy == null) {
			this.maxY = tar._height;
		} else {
			this.maxY = maxy;
		}
		if (sp == null) {
			this.swapPoint = this.minY;
		} else {
			this.swapPoint = sp;
		}
		//var o:Object = this.checkFlip(tar);
		//this.swapPoint *= o.y;
		//
		this.oDepth = tar.getDepth();
		tar.onUnload = function():Void  {
			this.mcBound.removeMovieClip();
		};
		//var oTmp:Object = this.mcObject.getBounds(_root);
		//
		this.bbBound.xMin = this.bbBound.xMin-this.mcObject._x;
		this.bbBound.yMin = this.bbBound.yMin-this.mcObject._y;
		this.bbBound.xMax = this.bbBound.xMax-this.mcObject._x;
		this.bbBound.yMax = this.bbBound.yMax-this.mcObject._y;
		//trace("ox: "+this.sw+" rx: "+this.bbBound.xMin);
		//
		_root.sortObjects();
		//
	}
	// Gives a KamiObject process time
	// Swaps depths and checks for collisions
	public function process(bSwap:Boolean):Void {
		if (this.mcObject._x+this.bbBound.xMin+_root._x>_root.swidth || this.mcObject._x+this.bbBound.xMax+_root._x<0 || this.mcObject._y+this.bbBound.yMin+_root._y>_root.sheight || this.mcObject._y+this.bbBound.yMax+_root._y<0) {
			this.mcObject._visible = false;
			return;
		}
		this.mcObject._visible = true;
		// swaping depth
		if (bSwap || bSwap == null) {
			if (_root.Player._y>this.mcObject._y+this.swapPoint) {
				if (this.mcObject.getDepth() == this.oDepth) {
					this.mcObject.swapDepths(this.lDepth);
				}
			} else {
				if (this.mcObject.getDepth() != this.oDepth) {
					this.mcObject.swapDepths(this.oDepth);
				}
			}
		}
		if (this.minX != this.maxX) {
			// hit test --------------         
			// collision
			this.tx = _root.Player._x+_root.PBX;
			this.ty = _root.Player._y+_root.PBY;
			if (_root.PlayerMove != 2) {
				if( _root.Player._x>=this.mcObject._x+this.minX && _root.Player._x<=this.mcObject._x+this.maxX ) {
					if( (_root.Player._y<=this.mcObject._y+this.minY && this.ty>this.mcObject._y+this.minY) || (_root.Player._y>=this.mcObject._y+this.maxY && this.ty<this.mcObject._y+this.maxY) ) {
						_root.PlayerMove = 2;
					}
				} else if( _root.Player._y>=this.mcObject._y+this.minY && _root.Player._y<=this.mcObject._y+this.maxY ) {
					if( (_root.Player._x<=this.mcObject._x+this.minX && this.tx>this.mcObject._x+this.minX) || (_root.Player._x>=this.mcObject._x+this.maxX && this.tx<this.mcObject._x+this.maxX) ) {
						_root.PlayerMove = 2;
					}
				}
				/*
				if ((this.tx>this.mcObject._x+this.minX && this.tx<this.mcObject._x+this.maxX) && (this.ty>this.mcObject._y+this.minY && this.ty<this.mcObject._y+this.maxY)) {
					_root.PlayerMove = 2;
				}
				*/
			} else {
				_root.PlayerMove = 1;
			}
			if (_root.Player._x+_root.speed>this.mcObject._x+this.bbBound.xMin && _root.Player._x-_root.speed<this.mcObject._x+this.bbBound.xMax) {
				if ((_root.Player._y+_root.speed>this.mcObject._y+this.bbBound.yMin && _root.Player._y-_root.speed<this.mcObject._y+this.bbBound.yMax) || (_root.Player._y-_root.Player._height/2>this.mcObject._y+this.bbBound.yMin && _root.Player._y-_root.Player._height/2<this.mcObject._y+this.bbBound.yMax)) {
					if (!this.bTouch) {
						this.onTouch(this.mcObject);
						this.bTouch = true;
					}
					if (this.onSpace != null) {
						if (Key.isDown(Key.SPACE)) {
							if (!_root.bSpaceState) {
								//trace("px: "+_root.Player._x+" ox: "+this.mcObject._x+" xmin: "+this.bbBound.xMin+" xmax: "+this.bbBound.xMax);
								//trace("py: "+_root.Player._y+" oy: "+this.mcObject._y+" ymin: "+this.bbBound.yMin+" ymax: "+this.bbBound.yMax);
								this.onSpace(this.mcObject);
								_root.bSpaceState = true;
							}
						} else {
							if (_root.bSpaceState) {
								_root.bSpaceState = false;
							}
						}
					}
				} else {
					this.bTouch = false;
				}
			} else {
				this.bTouch = false;
			}
		}
		// Debug         
		//DEBUG
		if (Key.isDown(78)) {
			if (this.mcObject.mcBound == null) {
				_root.setRandomFact(6);
				this.mcObject.createEmptyMovieClip("mcBound", this.mcObject.getNextHighestDepth());
				var fs:Object = this.checkFlip(this.mcObject);
				this.mcObject.mcBound.lineStyle(1, fs.x!=1 || fs.y!=1 ? 0x11aaee : 0x00ff00, 100);
				this.mcObject.mcBound.moveTo(this.minX*fs.x, this.minY*fs.y);
				this.mcObject.mcBound.lineTo(this.maxX*fs.x, this.minY*fs.y);
				this.mcObject.mcBound.lineTo(this.maxX*fs.x, this.maxY*fs.y);
				this.mcObject.mcBound.lineTo(this.minX*fs.x, this.maxY*fs.y);
				this.mcObject.mcBound.lineTo(this.minX*fs.x, this.minY*fs.y);
			} else {
				this.mcObject.mcBound._visible = true;
			}
		} else {
			this.mcObject.mcBound._visible = false;
		}
		//DEBUG 2
		if (Key.isDown(86)) {
			if (this.mcObject.mcBound2 == null) {
				_root.setRandomFact(6);
				//
				this.mcObject.createEmptyMovieClip("mcBound2", this.mcObject.getNextHighestDepth());
				this.mcObject.mcBound2.lineStyle(1, 0x22bb22, 100);
				var fs:Object = this.checkFlip(this.mcObject);
				this.mcObject.mcBound2.moveTo(this.bbBound.xMin*fs.x, this.bbBound.yMin*fs.y);
				this.mcObject.mcBound2.lineTo(this.bbBound.xMax*fs.x, this.bbBound.yMin*fs.y);
				this.mcObject.mcBound2.lineTo(this.bbBound.xMax*fs.x, this.bbBound.yMax*fs.y);
				this.mcObject.mcBound2.lineTo(this.bbBound.xMin*fs.x, this.bbBound.yMax*fs.y);
				this.mcObject.mcBound2.lineTo(this.bbBound.xMin*fs.x, this.bbBound.yMin*fs.y);
				//
			} else {
				this.mcObject.mcBound2._visible = true;
			}
		} else {
			this.mcObject.mcBound2._visible = false;
		}
		// Swap Point
		if (Key.isDown(66)) {
			_root.setRandomFact(6);
			if (this.mcObject.mcSP == null) {
				this.mcObject.createEmptyMovieClip("mcSP", this.mcObject.getNextHighestDepth());
				this.mcObject.mcSP.lineStyle(6, 0xffff00);
				this.mcObject.mcSP.moveTo(0, this.swapPoint);
				this.mcObject.mcSP.lineTo(0, this.swapPoint+1);
				//
				this.mcObject.createTextField("tfDepth", this.mcObject.getNextHighestDepth(), 0, 0, 0, 0);
				this.mcObject.tfDepth.selectable = false;
				this.mcObject.tfDepth.embedFonts = true;
				this.mcObject.tfDepth.autoSize = true;
				this.mcObject.tfDepth.setNewTextFormat(_root.format);
			} else {
				this.mcObject.mcSP._visible = true;
				this.mcObject.tfDepth._visible = true;
			}
			this.mcObject.tfDepth.text = ""+this.mcObject.getDepth();
		} else {
			this.mcObject.mcSP._visible = false;
			this.mcObject.tfDepth._visible = false;
		}
	}
	/*
	// it actually leaves unloading to Flash, which can lead to unwanted results
	public function doUnload():Void {
		if (this.mcObject.getDepth() != this.oDepth) {
			this.mcObject.swapDepths(this.oDepth);
		}
	}
	*/
	public function doUnload():Void {
		this.mcObject.swapDepths(this.mcObject._parent.getNextHighestDepth());
		_root.removeMovie(this.mcObject);
	}
	public function getMC():MovieClip {
		return this.mcObject;
	}
	public function setLowDepth(n:Number):Void {
		this.lDepth = n;
	}
	public function getLDepth():Number {
		return this.lDepth;
	}
	//
	private function checkFlip(mc:MovieClip):Object {
		var xs:Number = mc._xscale;
		var ys:Number = mc._yscale;
		mc._xscale = 100;
		mc._yscale = 100;
		var o1:Object = new Object();
		var o2:Object = new Object();
		var r:Object = new Object();
		r.x = 1;
		r.y = 1;
		o1.x = 10;
		o1.y = 10;
		o2.x = mc._x+10;
		o2.y = mc._y+10;
		mc.localToGlobal(o1);
		mc._parent.localToGlobal(o2);
		if (o1.x != o2.x) {
			if (o1.y != o2.y) {
				r.x = -1;
				r.y = -1;
			} else {
				r.x = -1;
			}
		} else if (o1.y != o2.y) {
			r.y = -1;
		}
		mc._xscale = xs;
		mc._yscale = ys;
		xs = mc._xscale/100;
		ys = mc._yscale/100;
		r.x /= xs;
		r.y /= ys;
		return r;
	}
}
