﻿// Used by Kamineko Battle Engine
// 6th frame of Character's animtion is used to show Potion usage
// Set to 'false' if you want Character to simple stand and do nothing.
// It will affect both Player's Characters and Enemies 
var usePotionAnim:Boolean = false;

var mcsCount:Number = _root.playersCount>_root.monstersCount ? _root.playersCount : _root.monstersCount;
var kbcCurrent:KamiBattleChar = null;
var kbcCurrentPlayer:KamiBattleChar = null;
var kbcPrioPlayer:KamiBattleChar = null;
var kbcTarget:KamiBattleChar = null;
var aChars:Array = new Array();
var aPlayers:Array = new Array();
var aMons:Array = new Array();
for (var j:Number=1; j<=_root.playersCount; j++) {
	if (_root.aPlayerTeam[j][0][0] != null) {
		_root.aChars[_root.aChars.length] = new KamiBattleChar(true,j,!_root.aPlayerTeam[j][0][15],_root.aPlayers);
		//For AI to choose from, damage dealing and after fight cleanup
		_root.aPlayers[_root.aPlayers.length] = _root.aChars[_root.aChars.length-1];
	}
}
for (var j:Number=1; j<=_root.monstersCount; j++) {
	if (_root.aEnemyTeam[j][0][0] != null) {
		_root.aChars[_root.aChars.length] = new KamiBattleChar(false,j,false,_root.aMons);
		//For AI to choose from, damage dealing and after fight clean up
		_root.aMons[_root.aMons.length] = _root.aChars[_root.aChars.length-1];
	}
}

//
//
var chooseCommand:Function = function(n:Number):Void {
	if (_root.kbcPrioPlayer != null) {
		_root.kbcPrioPlayer.setMove(n);
	} else {
		_root.kbcCurrentPlayer.setMove(n);
	}
}
//
var sendCommandHeal:Function = function(p:Number):Void {
	if (_root.kbcPrioPlayer != null) {
		_root.kbcPrioPlayer.doHeal(p);
	} else {
		_root.kbcCurrentPlayer.doHeal(p);
	}
}
var sendCommandMana:Function = function(p:Number):Void {
	if (_root.kbcPrioPlayer != null) {
		_root.kbcPrioPlayer.doMana(p);
	} else {
		_root.kbcCurrentPlayer.doMana(p);
	}
}
//
//
var summonMonster:Function = function():Void {
	//aMonSummons
	for(var i:Number = 1; i <= _root.montersCount; i++) {
		if( _root.aEnemyTeam[i][0][5] == null ) {
			_root.aEnemyTeam[i] = _root.arrayCopy( _root.aMonSummons[random(_root.aMonSummons.length)] );
			_root.aChars[_root.aChars.length] = new KamiBattleChar(false,i,false,_root.aMons);
			//For AI to choose from, damage dealing and after fight clean up
			_root.aMons[_root.aMons.length] = _root.aChars[_root.aChars.length-1];
			return;
		}
	}
	var tmpID:Number = -1;
	for(var j:Number = 1; j <= _root.aMons.length; j++) {
		if( !_root.aMons[j].isAlive() ) {
			tmpID = _root.aMons[j].getID();
			_root.aMons[j].removeChar();
			_root.aEnemyTeam[tmpID] = _root.arrayCopy( _root.aMonSummons[random(_root.aMonSummons.length)] );
			for(var char in _root.aChars) {
				if( _root.aChars[char]==_root.aMons[j] ) {
					_root.aChars[j] = new KamiBattleChar(false,tmpID,false,_root.aMons);
					_root.aMons[j] = _root.aChars[j];
					return;
				}
			}
		}
	}
}
var canSummonMon:Function = function():Boolean {
	for(var i:Number = 1; i <= _root.montersCount; i++) {
		if( _root.aEnemyTeam[i][0][5] == null ) {
			return true;
		}
	}
	for(var j:Number = 1; j <= _root.aMons.length; j++) {
		if( !_root.aMons[j].isAlive() ) {
			return true;
		}
	}
	return false;
}
	
	
			