﻿var mover:Function = function (to:MovieClip, rx:Number, ry:Number, speed:Number):Void {
	if (to.t == undefined) {
		to.t = 0;
		to.cx = to._x;
		to.cy = to._y;
	}
	if (to.t<0) {
		to.t = 40+Math.random()*30;
		to.vx = -1+(Math.random()*2);
		to.vy = -1+(Math.random()*2);
	} else {
		if (to._x>to.cx+rx) {
			to.vx = Math.abs(to.vx)*-1;
		} else if (to._x<to.cx-rx) {
			to.vx = Math.abs(to.vx);
		}
		to._x += to.vx*speed;
		if (to._y>to.cy+ry) {
			to.vy = Math.abs(to.vy)*-1;
		} else if (to._y<to.cy-ry) {
			to.vy = Math.abs(to.vy);
		}
		to._y += to.vy*speed;
		to.t--;
	}
};
var moverPath:Function = function (to:MovieClip):Void {
	if (to.tar == null) {
		to.tar = 0;
		to.spd = to.aPathPoints[0][2];
		to.tout = 0;
		to.ang = Math.atan2(to.aPathPoints[to.tar][1]-to._y, to.aPathPoints[to.tar][0]-to._x);
	} else {
		if (to.tout<=0) {
			if (to.aPathPoints[to.tar][0]-to.spd<=to._x && to.aPathPoints[to.tar][0]+to.spd>=to._x) {
				to._x = to.aPathPoints[to.tar][0];
			} else {
				to._x += Math.cos(to.ang)*to.spd;
			}
			if (to.aPathPoints[to.tar][1]-to.spd<=to._y && to.aPathPoints[to.tar][1]+to.spd>=to._y) {
				to._y = to.aPathPoints[to.tar][1];
			} else {
				to._y += Math.sin(to.ang)*to.spd;
			}
			if (to._y == to.aPathPoints[to.tar][1] && to._x == to.aPathPoints[to.tar][0]) {
				to.tout = to.aPathPoints[to.tar][3];
				to.spd = to.aPathPoints[to.tar][2];
				if (to.tar>=to.aPathPoints.length-1) {
					to.tar = 0;
				} else {
					to.tar++;
				}
				to.ang = Math.atan2(to.aPathPoints[to.tar][1]-to._y, to.aPathPoints[to.tar][0]-to._x);
			}
		} else {
			to.tout--;
		}
	}
};
