﻿// Flags
var gameFlags:Object = new Object();
var setFlag:Function = function (flag:String, b:Boolean):Void {
	if (b == null) {
		b = true;
	}
	_root.gameFlags[flag] = b;
};
var checkFlag:Function = function (flag:String):Boolean {
	return _root.gameFlags[flag];
};
var traceFlags:Function = function ():Void {
	for (ind in _root.gameFlags) {
		trace(""+ind+" : "+_root.gameFlags[ind]);
	}
};
// Variables
var gameVars:Object = new Object();
var setVar:Function = function (v:String, n:Number):Void {
	_root.gameVars[v] = n;
};
var checkVar:Function = function (v:String):Number {
	return _root.gameVars[v];
};
var traceVars:Function = function ():Void {
	for (ind in _root.gameVars) {
		trace(""+ind+" : "+_root.gameVars[ind]);
	}
};
//LOAD FUNCTION
var loadGame:Function = function ():Void {
	var store:SharedObject = SharedObject.getLocal("Game-Kamineko", "/");
	if (store.data.verKami != _root.verKami) {
		_root.SMS("Save version mismatch!", 50);
		return;
	}
	if(store.data.CurLevel!=_root._currentframe) {
	//KamiObjects reset
		for (var index in _root.aKamiObjects) {
			_root.aKamiObjects[index].doUnload();
		}
		_root.aKamiObjects = new Array();
		_root.aLights = new Array();
		_root.playMusic("");
	}
	// Variables
	_root.verKami = store.data.verKami;
	_root.gameFlags = store.data.gameFlags;
	_root.gameVars = store.data.gameVars;
	// interface
	_root.showStats = store.data.showStats;
	_root.showItems = store.data.showItems;
	_root.showEquip = store.data.showEquip;
	_root.showIcons = store.data.showIcons;
	_root.showPlay = store.data.showPlay;
	_root.showPlayer = store.data.showPlayer;
	_root.showPotions = store.data.showPotions;
	_root.showCash = store.data.showCash;
	_root.showFightIcon = store.data.showFightIcon;
	_root.displayStatus(_root.showStats);
	_root.displayItems(_root.showItems);
	_root.displayEquip(_root.showEquip);
	_root.displayIcons(_root.showIcons);
	_root.displayPlaylist(_root.showPlay);
	_root.displayPlayer(_root.showPlayer);
	_root.displayCashIcon(_root.showCash);
	_root.displayFightIcon(_root.showFightIcon);
	// cash
	_root.cash = store.data.cash;
	_root.refreshCash();
	// cheating
	_root.cheat = store.data.cheat;
	_root.bCheater = store.data.bCheater;
	_root.Inter.tfCheater._visible = _root.cheat;
	// Potions
	_root.heal = store.data.heal;
	_root.mana = store.data.mana;
	_root.displayPotions(_root.showPotions);
	// other
	_root.playersCount = store.data.playersCount;
	_root.monstersCount = store.data.monstersCount;
	_root.playerAnimate = store.data.playerAnimate;
	_root.playerCanMove = store.data.playerCanMove;
	_root.speed = store.data.speed;
	_root.scrollEffect = store.data.scrollEffect;
	_root.blackMap = store.data.blackMap;
	_root.battleFrame = store.data.battleFrame;
	_root.eBack = store.data.eBack;
	_root.deadFrame = store.data.deadFrame;
	_root.timeFlow = store.data.timeFlow;
	_root.setTimeFlow(_root.timeFlow);
	_root.sunEffect = store.data.sunEffect;
	_root.Sun = store.data.Sun;
	_root.autoSave = store.data.autoSave;
	_root.allowSave = store.data.allowSave;
	_root.worldMap = store.data.worldMap;
	_root.musicAuto = store.data.musicAuto;
	_root.musVol = store.data.musVol;
	_root.allowLights = store.data.allowLights;
	_root.allowBattleRun = store.data.allowBattleRun;
	_root.allowKeys = store.data.allowKeys;
	_root.hr = store.data.hr;
	_root.mi = store.data.mi;
	_root.pickups = store.data.pickups;
	_root.walky = store.data.walky;
	_root._currentframe = store.data.CurLevel;
	_root.Player._x = store.data.playerX;
	_root.Player._y = store.data.playerY;
	_root.chooseBattleSong = store.data.chooseBattleSong;
	_root.noMusicFade = store.data.noMusicFade;
	_root.battleSongs = store.data.battleSongs;
	_root.daysPlayed = store.data.daysPlayed;
	_root.aPlayerTeam = store.data.aPlayerTeam;
	for (var j:Number=1; j<=_root.playersCount; j++) {
		if (_root.aPlayerTeam[j][0][0] != null) {
			_root.aPlayerTeam[j][0][13] = _root.getDBPlayer(_root.aPlayerTeam[j][0][0])[1][13];
			_root.aPlayerTeam[j][0][13](_root.aPlayerTeam[j][0],_root.aPlayerTeam[j][1],_root.aPlayerTeam[j][2]);
		}
	}
	// Reset
	_root.removeTalk(_root.tempTo);
	_root.removeFollower(_root.Follower);
	_root.SMS("", 0);
	_root.moveTime(0);
	_root.sunset.setTransform(_root.trans);
	_root.refreshHUD();
	_root.refreshItems();
	//
	_root.gotoAndStop(store.data.CurLevel);
};
//SAVE FUNCTION
var saveGame:Function = function ():Void {
	var store:SharedObject = SharedObject.getLocal("Game-Kamineko", "/");
	store.clear();
	//
	store.data.aKamiObjects = _root.aKamiObjects;
	store.data.aLights = _root.aLights;
	//
	store.data.verKami = _root.verKami;
	store.data.gameFlags = _root.gameFlags;
	store.data.gameVars = _root.gameVars;
	// interface
	store.data.showStats = _root.showStats;
	store.data.showItems = _root.showItems;
	store.data.showEquip = _root.showEquip;
	store.data.showIcons = _root.showIcons;
	store.data.showPlay = _root.showPlay;
	store.data.showPlayer = _root.showPlayer;
	store.data.showPotions = _root.showPotions;
	store.data.showCash = _root.showCash;
	store.data.showFightIcon = _root.showFightIcon;
	// other
	store.data.playersCount = _root.playersCount;
	store.data.monstersCount = _root.monstersCount;
	store.data.playerAnimate = _root.playerAnimate;
	store.data.playerCanMove = _root.playerCanMove;
	store.data.speed = _root.speed;
	store.data.cash = _root.cash;
	store.data.scrollEffect = _root.scrollEffect;
	store.data.blackMap = _root.blackMap;
	store.data.battleFrame = _root.battleFrame;
	store.data.eBack = _root.eBack;
	store.data.deadFrame = _root.deadFrame;
	store.data.timeFlow = _root.timeFlow;
	store.data.sunEffect = _root.sunEffect;
	store.data.Sun = _root.Sun;
	store.data.autoSave =_root.autoSave;
	store.data.allowSave = _root.allowSave;
	store.data.worldMap = _root.worldMap;
	store.data.musicAuto = _root.musicAuto;
	store.data.musVol = _root.musVol;
	store.data.allowLights = _root.allowLights;
	store.data.allowBattleRun = _root.allowBattleRun;
	store.data.allowKeys = _root.allowKeys;
	store.data.hr = _root.hr;
	store.data.mi = _root.mi;
	store.data.heal = _root.heal;
	store.data.mana = _root.mana;
	store.data.pickups = _root.pickups;
	store.data.walky = _root.walky;
	store.data.cheat = _root.cheat;
	store.data.bCheater = _root.bCheater;
	store.data.CurLevel = _root._currentframe;
	store.data.playerX = _root.Player._x;
	store.data.playerY = _root.Player._y;
	store.data.chooseBattleSong = _root.chooseBattleSong;
	store.data.noMusicFade = _root.noMusicFade;
	store.data.battleSongs = _root.battleSongs;
	store.data.daysPlayed = _root.daysPlayed;
	store.data.aPlayerTeam = _root.aPlayerTeam;
	store.flush();
};
