﻿// Time -------------------------------------------------------------
// hr:mi
var hr:Number = 10;
var mi:Number = 22;

//just for stats
var daysPlayed:Number = 0;
//
var allowSave:Boolean = true;
var sunEffect:Boolean = true;
var Sun:Boolean = true;
var timeFlow:Boolean = false;
// TIME -------------------------------------------------------------
// procent and offset vars are for color transformation (sunset effect)
var trans:Object = new Object();
trans.ra = 100;
//procent
trans.rb = 0;
//offset
trans.ga = 100;
//procent
trans.gb = 0;
//offset
trans.ba = 100;
//procent
trans.bb = 0;
//offset
trans.aa = 100;
//procent
trans.ab = 0;
//offset
var tmpRB:Number = 0;
//is used to check whether enviroment color changed
var sunset:Color = new Color(_root);
sunset.setTransform(trans);
var trans2:Object = new Object();
trans2.rb = -_root.trans.rb;
trans2.gb = -_root.trans.gb;
trans2.bb = -_root.trans.bb;
trans2.ab = -_root.trans.ab;
//
_root.Inter.createTextField("timex", _root.Inter.getNextHighestDepth(), 100, 83, 50, 32);
_root.Inter.timex.selectable = false;
_root.Inter.timex.embedFonts = true;
_root.Inter.timex.setNewTextFormat(_root.format);
_root.Inter.timex._visible = false;
//
var timeProcess:Function = function():Void {
	//SUNSET
	_root.moveTime(0.1);
}
_root.addProcessingModule(timeProcess);
//
var moveTime:Function = function (ile:Number):Void {
	if (_root.timeFlow) {
		//MOVING TIME
		_root.mi += ile;
		if (_root.mi>=60) {
			_root.hr++;
			_root.mi -= 60;
		}
		if (_root.hr>=24) {
			_root.hr = 0;
			_root.daysPlayed++;
			if (_root.autoSave && !this.beginSave) {
				this.beginSave = true;
			}
		}
		//Clock update   
		//_root.Inter.timex._visible = _root.timeFlow;
		if (_root.hr<10) {
			if (_root.mi<10) {
				_root.Inter.timex.text = "0"+_root.hr+":0"+Math.floor(_root.mi);
			} else {
				_root.Inter.timex.text = "0"+_root.hr+":"+Math.floor(_root.mi);
			}
		} else if (_root.mi<10) {
			_root.Inter.timex.text = ""+_root.hr+":0"+Math.floor(_root.mi);
		} else {
			_root.Inter.timex.text = ""+_root.hr+":"+Math.floor(_root.mi);
		}
		//AUTO SAVE                       
		if (this.beginSave) {
			if (_root.allowSave && !_root.sell && !_root.inFight && !_root.WorldMapInterface._visible) {
				_root.saveGame();
				_root.SMS("Game has been automaticly saved", 45);
				this.beginSave = false;
			}
		}
		//MUSIC FADING                          
		if (_root.hr>=21 && _root.hr<=23) {
			_root.setMusicVolume(100-(((((_root.hr-21)*60)+_root.mi)/180)*100));
		} else if (_root.hr>=6 && _root.hr<=8) {
			_root.setMusicVolume(((((_root.hr-6)*60)+_root.mi)/180)*100);
		} else if (_root.hr>8 && _root.hr<21) {
			_root.setMusicVolume(100);
		} else if (_root.hr<6) {
			_root.setMusicVolume(0);
		}
	}
	//SUNSET EFFECT CHANGING                          
	_root.doSunset();
};
function setTimeFlow(b:Boolean):Void {
	_root.timeFlow = b;
	_root.Inter.timex._visible = b;
}
function setSun(b:Boolean):Void {
	_root.Sun = b;
	_root.doSunset();
}
function doSunset():Void {
	if (_root.sunEffect) {
		if (!_root.Sun) {
			_root.trans.rb = 0;
			_root.trans.gb = 0;
			_root.trans.bb = 0;
			_root.trans.ab = 0;
			_root.playSound("cricket", false, -1);
		} else {
			if (_root.hr>=18 && _root.hr<=20) {
				_root.trans.rb = (((((_root.hr-18)*60)+_root.mi)/180)*100);
				_root.trans.gb = 0;
				_root.trans.bb = 0;
				_root.trans.ab = 0;
			} else if (_root.hr>=21 && _root.hr<=23) {
				_root.trans.rb = 100-(((((_root.hr-21)*60)+_root.mi)/180)*250);
				_root.trans.gb = -(((((_root.hr-21)*60)+_root.mi)/180)*150);
				_root.trans.bb = -(((((_root.hr-21)*60)+_root.mi)/180)*100);
				_root.trans.ab = 0;
			} else if (_root.hr<=5) {
				_root.trans.rb = -150;
				_root.trans.gb = -150;
				_root.trans.bb = -100;
				_root.trans.ab = 0;
				//_root.fadeMusic(0);
				_root.playSound("cricket", false, 999);
			} else if (_root.hr>=6 && _root.hr<=8) {
				_root.trans.rb = -150+(((((hr-6)*60)+_root.mi)/180)*150);
				_root.trans.gb = -150+(((((hr-6)*60)+_root.mi)/180)*150);
				_root.trans.bb = -100+(((((hr-6)*60)+_root.mi)/180)*100);
				_root.trans.ab = 0;
				_root.playSound("cricket", false, -1);
			}
		}
		if (_root.tmpRB != _root.trans.rb) {
			_root.sunset.setTransform(_root.trans);
			_root.trans2.rb = -_root.trans.rb;
			_root.trans2.gb = -_root.trans.gb;
			_root.trans2.bb = -_root.trans.bb;
			_root.trans2.ab = -_root.trans.ab;
			_root.cInterColor.setTransform(_root.trans2);
			if (_root.inFight) {
				_root.cBInterColor.setTransform(_root.trans2);
			}
			_root.tmpRB = _root.trans.rb;
		}
		for (var index in _root.aLights) {
			_root.aLights[index].sunset.setTransform(_root.trans2);
		}
	}
}