﻿//players cash
var cash:Number = 20;


//A main timeline's frame that has the battle engine implemented
var battleFrame:String = "BattleFrame";
//where player returns after his death
var deadFrame:String = "GameStart";
//version of the game
//this variable is included into the save game data
//save game data's verKami != current verKami and Kamineko engine will throw an error 
var verKami:Number = 1004;

// Playlist ---------------------------------------------------------
// List of songs
// (*) a locked song (false) can not be selected from the playlist till it plays for the first time.
// lista[i] = [relative path to music file, name of a song, unlocked?*]
var lista:Array = new Array();
lista.push( new Array("1stround", "Ikkitousen - 1 Round", false) );
lista.push( new Array("2ndround", "Ikkitousen - 2 Round", false) );
lista.push( new Array("3rdround", "Ikkitousen - 3 Round", true) );
lista.push( new Array("Morning", "Chobits - Morning", true) );
lista.push( new Array("Observe", "X-Change - Observe", true) );
lista.push( new Array("PKM", "Peace Maker Kurogane", true) );
lista.push( new Array("Tension", "Initial D - Tension", false) );
lista.push( new Array("BeyondGnE", "Beyond Good & Evil", false) );
lista.push( new Array("Azumanga", "Azumanga", false) );
lista.push( new Array("Diablo", "Diablo - Dungeon", false) );
lista.push( new Array("Million", "Millionaire - Question", false) );
lista.push( new Array("FateStayNight", "Fate/stay Night - Kasei Otto wa Seigi no Mikata", false) );
lista.push( new Array("Coldplay", "Coldplay - Violet Hill", true) );
// In-battle music
// Choose songs to play during the battle sequences
battleSongs[0] = "Ikkitousen - 1 Round";
battleSongs[1] = "Ikkitousen - 2 Round";
battleSongs[2] = "Ikkitousen - 3 Round";
_root.setSongList(_root.lista);
// Player characters
_root.readDBPlayer(1);
_root.readDBPlayer(2,"Sakaki");
_root.readDBPlayer(3);

// ===========================================================================
// KamiFight.as
// ---------------------------------------------------------------------------
//
// Monster summons
// List of monsters for summoning
var aMonSummons = new Array();
//
var showBack:Array = new Array(0, 0, 0, 0,0,0);
var onFightCancel:Function = function():Void {
	_root.fade(0, 1, 10);
}
//
var onRandomEncounter:Function = function (song:String):Void {
	if(song!=null) _root.playMusic(song);
	_root.fade(0, 1, 10, _root.fightInit);
}
// Stuff to do when entering a fight
var fightInit:Function = function():Void {
	_root.allowSave = false;
	_root.showBack = [_root.showStats, _root.showItems, _root.showEquip, _root.showIcons,_root.scrollEffect,_root.blackMap];
	_root.displayStatus(false);
	_root.displayItems(false);
	_root.displayEquip(false);
	_root.displayIcons(true);
	_root.displayPlayer(false);
	_root.displayPotions(false);
	_root.displayFollower(false);
	_root.blackness._visible = false;
	_root.aLights = new Array();
	_root.scrollEffect = 0;
	_root.disableKeyListener();
	_root.blackMap = false;
	_root.fightStart();
	_root.changeLevel(_root.battleFrame, 0, 0);
}

var warpTo:Function = function(to:String, nx:Number, ny:Number):Boolean  {
	if(!_root.inFight) {
		_root.resetSounds();
		_root.changeLevel(to, nx, ny);
		_root.aLights = new Array();
		return true;
	}
	return false;
}

/* ========================================================================
Misc.
===========================================================================
*/
_root.playerCanMove = false;
_root.allowBattleRun = false;
_root.Sun = false;
_root.bEnemyArea = false;
_root.blackMap = false;
_root.scrollEffect = 0;
_root.allowKeys = false;
//
_root.displayStatus(false);
_root.displayItems(false);
_root.displayEquip(false);
_root.displayIcons(false);
_root.displayPlaylist(false);
_root.displayPlayer(false);
_root.displayPotions(false);
_root.displayCashIcon(false);
_root.displayFightIcon(false);
_root.setTimeFlow(false);