﻿class classes.KamiBattleChar {
	//char setting
	private var bHuman:Boolean = true;
	private var bAlly:Boolean = true; //Ally or Foe (Char or Mon)
	private var sType:String = ""; //mon or char
	// states
	private var bHit:Boolean = false;
	private var bEnd:Boolean = false;
	private var bDef:Boolean = false;
	//
	private var nID:Number = 0;
	private var nCooldown:Number = 0;
	private var nDmg:Number = 0;
	private var nMoveType:Number = 0;
	// Berserk
	private var bBerserk:Boolean = false;
	private var bBerserkAI:Boolean = false;
	private var nBerserkTime:Number = 0;
	// Potion
	private var nPotion:Number = 0;
	private var bPotionType:Boolean = false;
	// Summon
	private var bSummon:Boolean = false;
	private var sSummonName:String = "";
	// Set on fire
	private var aFire:Array = null;
	private var nFireOut:Number = 0;
	//
	private var aChar:Array = null;
	private var aItem:Array = null;
	private var aSkill:Array = null;
	private var aStatChange:Array = null;
	private var aGroup:Array = null;
	//
	private var kbcTarget:KamiBattleChar = null;
	private var mcChar:MovieClip = null;
	private var mcAnim:MovieClip = null;
	private var mcPointer:MovieClip = null;
	private var mcCoolBar:MovieClip = null;
	//
	//Defend heal calc
	private var nHP:Number = 0;
	private var nMP:Number = 0;
	//
	private var mcLoad:MovieClipLoader = null;
	function KamiBattleChar(char:Boolean, id:Number, human:Boolean, group:Array) {
		this.aGroup = group;
		this.bHuman = human;
		this.bAlly = char;
		if(this.bAlly) this.sType = "char";
		else this.sType = "mon";
		//
		//Next Character to load
		_root.toLoad++;
		//
		//Chracter's MovieClip
		this.mcChar = _root.BChar.createEmptyMovieClip(this.sType+id+"_c", _root.BChar.getNextHighestDepth());
		this.mcChar._y = 250+((150/_root.mcsCount)*(id-1));
		this.mcChar._x = !char ? _root.swidth-(Math.abs((id+1)%2)*35)-50 : 50+(Math.abs((id+1)%2)*35);
		//
		//Local reference to character's stats
		if (char) {
			this.aChar = _root.aPlayerTeam[id][0];
			this.aItem = _root.aPlayerTeam[id][1];
			this.aSkill = _root.aPlayerTeam[id][2];
			// Cooldown bar
			this.mcCoolBar = _root.BChar.createEmptyMovieClip(this.sType+id+"_bar", _root.BChar.getNextHighestDepth());
			this.mcCoolBar._x = 50+(((_root.swidth-50)/_root.playersCount)*(id-1));
			this.mcCoolBar._y = 132;
			//Summons (disabled for now)
			this.sSummonName = this.aChar[14];
			this.bSummon = false;
		} else {
			this.aChar = _root.aEnemyTeam[id][0];
			this.aItem = _root.aEnemyTeam[id][1];
			this.aSkill = _root.aEnemyTeam[id][2];
			// HP and MP recalculation  
			this.aChar[6] = this.aChar[2]*10;
			this.aChar[5] = this.aChar[6];
			this.aChar[8] = this.aChar[4]*5;
			this.aChar[7] = this.aChar[8];
			//
			_root.expToGive += this.aChar[10];
			_root.cashToGive += this.aChar[10];
			_root.kbsStat.addText(this.aChar[0]+" appears!\n");
			_root.kbcTarget = this;
			// Monster summons
			this.sSummonName = null;
			this.bSummon = this.aItem[4];
		}
		
		//
		//Overhead, character pointer
		this.mcPointer = _root.BInter.CommMenu.attachMovie("Battle_Pointer", this.sType+id+"_p", _root.BInter.CommMenu.getNextHighestDepth());
		this.mcPointer._x = this.mcChar._x-_root.BInter.CommMenu._x;
		this.mcPointer.parent = this;
		this.mcPointer._visible = true;
		this.mcPointer.onPress = function():Void  {
			this.gotoAndStop(2);
			this.parent.setAutoTarget();
		};
		this.mcPointer.onEnterFrame = function():Void  {
			if (this.parent != _root.kbcTarget) {
				if (this.parent.isCool()) {
					this.gotoAndStop(3);
				} else {
					this.gotoAndStop(1);
				}
			} else {
				this.gotoAndStop(2);
			}
		};
		//y after character is loaded
		//
		this.nID = id;
		this.aStatChange = new Array("", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
		this.aFire = new Array();
		this.nFireOut = _root.nFireTime;
		//
		//Animation
		// First, trying to attach a MovieClip from the Library
		this.mcAnim = this.mcChar.attachMovie(this.sType+"_"+(this.bAlly ? this.aChar[0] : this.aChar[9]), "anim", this.mcChar.getNextHighestDepth());
		//if no mc was attached, trying to load it from external file
		if (this.mcAnim == null) {
			this.mcAnim = this.mcChar.createEmptyMovieClip("anim", this.mcChar.getNextHighestDepth());
			this.mcLoad = new MovieClipLoader();
			this.mcLoad.addListener(this);
			this.mcLoad.loadClip(this.sType+"_"+(this.bAlly ? this.aChar[0] : this.aChar[9])+".swf", this.mcAnim);
		} else {
			_root.readLoad++;
			if (this.aChar[5]>0) {
				this.mcAnim.gotoAndStop(1);
			} else {
				this.mcAnim.gotoAndStop(4);
			}
			//_root.BInter.CommMenu is not on a x=0 y=0 point 
			this.mcPointer._y = this.mcChar._y-this.mcAnim._height-30-_root.BInter.CommMenu._y;
		}
	}
	/*
	EVENTS ====================
	*/
	public function onLoadInit(mc:MovieClip):Void {
		this.mcPointer._y = this.mcChar._y-mc._height-30-_root.BInter.CommMenu._y;
		_root.readLoad++;
		if (this.aChar[5]>0) {
			mc.gotoAndStop(1);
		} else {
			mc.gotoAndStop(4);
		}
		this.mcLoad.removeListener(this);
	}
	public function onLoadError(mc:MovieClip):Void {
		_root.kbsStat.addText("\nERROR!\nFailed to load "+this.aChar[0]+"'s animations");
		this.mcLoad.removeListener(this);
	}
	/*
	MAIN LOOP =================
	*/
	public function process(bShow:Boolean):Boolean {
		if (this.aChar[5]>0) {
			//
			// State change
			if (this.mcChar.attacked != null) {
				// Older notation
				this.bHit = this.mcChar.attacked;
				this.mcChar.attacked = false;
			} else {
				this.bHit = this.mcChar.attack;
				this.mcChar.attack = false;
			}
			if (this.mcChar.endex != null) {
				// Older notation
				this.bEnd = this.mcChar.endex;
				this.mcChar.endex = false;
			} else {
				this.bEnd = this.mcChar.end;
				this.mcChar.end = false;
			}
			//
			// forcing MoveType 
			// Because "cho" can be changed, if statement shows ups twice
			// I can reformat that, but I don't really want to...
			if (_root.cho == 0) {
				if (this.nMoveType != 0) {
					_root.cho = this.nMoveType;
					this.nMoveType = 0;
				}
			}
			//
			// Damage over time
			if(this.nFireOut>0) {
				this.nFireOut--;
			} else {
				for(var idx in this.aFire) {
					this.aChar[5] -= this.aFire[idx][0];
					_root.playSound("firehit",false);
					_root.kbcControl.ColorEffect(200, 200, 0, 25, this.mcChar);
					_root.addFText(this.mcChar._x, this.mcChar._y-50, this.aFire[idx][0], 0xffff00);
					this.aFire[idx][1]--;
					if(this.aFire[idx][1]<=0) this.aFire.splice(parseInt(idx),1);
					if( this.checkDead() ) {
						_root.cho = 0;
						this.nCooldown = 0;
						return false;
					}
				}
				this.nFireOut = _root.nFireTime;
			}
			
			// Human or computer controled             
			if (_root.cho == 0) {
				//Resetting
				//
				// Defending heals a bit
				if(this.bDef) {
					this.bDef = false;
					this.nHP = 3 + Math.floor(this.bAlly?this.aChar[11]*2:this.aChar[10]/5);
					this.aChar[5]+= this.nHP;
					this.nMP = 1 + Math.floor(this.bAlly?this.aChar[11]:this.aChar[10]/10);
					this.aChar[7]+= 1 + this.nMP;
					if(this.aChar[5]>this.aChar[6]) this.aChar[5]=this.aChar[6];
					if(this.aChar[7]>this.aChar[8]) this.aChar[7]=this.aChar[8];
					//
					_root.kbsStat.addText("\n"+this.aChar[0]+" regained "+this.nHP+"HP and "+this.nMP+"MP");
					_root.addFText(this.mcChar._x-10, this.mcChar._y-55, "+"+this.nHP, 0xff0000);
					_root.addFText(this.mcChar._x+10, this.mcChar._y-45, "+"+this.nMP, 0x0000ff);
				}
				this.bHit = false;
				this.bEnd = false;
				this.mcAnim.gotoAndStop(1);
				this.mcAnim._xscale = 100;
				//
				if (this.bHuman) {
					// Player's decision time 
					if (!bShow) {
						// Human --------------------------
						//
						_root.showCommandMenu(true);
						for (var i:Number = 0; i<_root.nSkillsNumber; i++) {
							if (this.aSkill[i][7]) {
								_root.setCommandSkill(i,true,this.aSkill[i]);
								if (this.aChar[14] == "") _root.setCommandMain(4,75);
							} else {
								_root.setCommandSkill(i,false);
							}
						}
						return true;
					}
				} else {
					// AI ---------------------------------
					//
					if (!this.bBerserk) {
						while (this.nMoveType == 0) {
							//0.name 1.Str 2.Vit 3.Dex 4.Int 5.HP 6.MaxHP 7.MP 8.MaxMP 9.EP 10.MaxEP 11.LVL 12.picture 13.LVUP FUN()
							//AI chooses it's move type
							this.nMoveType = random(this.mcAnim._totalframes)+1;
							//Somewhat an AI
							//Changes it's move if has choosen to run, but doesnt need to, etc.
							// 1. attack
							// 2. defend
							// 3. heal
							// 4. not used (returns to 0)
							// 5. run
							// 6. summon
							// 10+. skills
							if (this.nMoveType>1) {
								switch (this.nMoveType) {
								case 2 :
									if (!this.aItem[1] || !(this.aChar[5]<this.aChar[6]/2)) {
										this.nMoveType = 1;
									}
									break;
								case 3 :
									if (this.aChar[5]<this.aChar[6]/2) {
										if (this.bAlly) {
											for (var i:Number = 0; i<_root.heal.length; i++) {
												if (_root.heal[i]>0) {
													this.doHeal(i);
													return false;
												}
											}
											this.nMoveType = 1;
										} else {
											if (!this.aItem[3] || this.aChar[7]<10) {
												this.nMoveType = 1;
											}
										}
									} else {
										this.nMoveType = 1;
									}
									break;
								case 4 :
									this.nMoveType = 0;
									break;
								case 5 :
									if (!this.aItem[2] || !(this.aChar[5]<this.aChar[6]/4) || !_root.allowBattleRun) {
										this.nMoveType = 1;
									}
									break;
								case 6 :
									if (!this.bAlly && this.bSummon &&_root.canSummonMon() && _root.aMonSummons!=null &&_root.aMonSummons.length>0 && this.aChar[7]>20) {
										this.nMoveType = 6;
										break;
									}
								case 7 :
								case 8 :
									this.nMoveType = 0;
									break;
									//case 6 :
									/*
									//No summons for now
									if (!this.aItem[4]) {
									this.nMoveType = 1;
									}
									break;
									*/
								default :
									if( this.aSkill==null || this.aSkill.length==0 ) {
										this.nMoveType = 1;
									} else {
										this.nMoveType = 9+((this.nMoveType-9)%(this.mcAnim._totalframes-8));
										if (this.aChar[7]<this.aSkill[this.nMoveType-9][6]) {
											this.nMoveType = 1;
										} else {
											//if(this.nMoveType != this.mcAnim._totalframes) this.nMoveType = 9+(this.nMoveType%(this.mcAnim._totalframes-9));
											
											// locked skill?
											if ( this.aSkill[this.nMoveType-9][7]!=null && !this.aSkill[this.nMoveType-9][7]) {
	
													for (var j:Number = 0; j<this.aSkill.length; j++) {
														if (this.aSkill[j][7]) {
															this.nMoveType = 9+j;
															break;
														}
													}

											}
											
											// No skill defined for this animation?
											if ( this.aSkill[this.nMoveType-9]==null) {
	
													for (var j:Number = 0; j<this.aSkill.length; j++) {
														if (this.aSkill[j]!=null) {
															this.nMoveType = 9+j;
															break;
														}
													}

											}
										}
									}
									break;
								}
							}
						}
						//AI's target  
						if (this.bAlly) {
							this.kbcTarget = _root.aMons[random(_root.aMons.length)];
							while (!this.kbcTarget.isAlive()) {
								this.kbcTarget = _root.aMons[random(_root.aMons.length)];
							}
						} else {
							this.kbcTarget = _root.aPlayers[random(_root.aPlayers.length)];
							while (!this.kbcTarget.isAlive()) {
								this.kbcTarget = _root.aPlayers[random(_root.aPlayers.length)];
							}
						}
						_root.cho = this.nMoveType;
						this.nMoveType = 0;
					} else {
						//Berserker mode!
						this.nBerserkTime--;
						if (this.nBerserkTime<=0) {
							this.bBerserk = false;
							this.bHuman = this.bBerserkAI;
						} else {
							_root.addFText(this.mcChar._x, this.mcChar._y-50, ""+this.nBerserkTime, 0xee0000);
							_root.kbcControl.ColorEffect(200, 0, 0, 25, this.mcChar);
						}
						//                         
						_root.cho = 1;
						this.kbcTarget = _root.aChars[random(_root.aChars.length)]
						while (!this.kbcTarget.isAlive()) {
							this.kbcTarget = _root.aChars[random(_root.aChars.length)];
						}
					}
				}
			} else {
				//Character made his choice
				_root.kbcControl.mcCurrent = this.mcChar;
				if (this.bHuman) {
					_root.kbcControl.mcTarget = _root.kbcTarget.getChar();
				} else {
					_root.kbcControl.mcTarget = this.kbcTarget.getChar();
				}
				//
				switch (_root.cho) {
				case 1 :
					//attack ------------
					this.mcAnim.gotoAndStop(5);
					if (this.bHit) {
						//  0.name 1.picture 2.type 3.dmg 4.maxDMG 5.all 6.cost 7.unlocked
						_root.kbcControl.doDamage(this, this.bHuman ? _root.kbcTarget : this.kbcTarget, ["attack", 0, 0, Math.round((this.aChar[1]+this.aItem[0][1])/2)+random(10)-5, null, 0, null, null]);
					}
					break;
				case 2 :
					//defend --------------
					this.bDef = true;
					_root.kbsStat.addText("\n"+this.aChar[0]+" is defending");
					this.mcAnim.gotoAndStop(3);
					_root.cho = 0;
					this.nCooldown = 0;
					break;
				case 3 :
					// potion -------------
					if (this.bHit || !_root.usePotionAnim) {
						_root.playSound("healing",false);
						if (this.bAlly) {
							if (this.bPotionType) {
								//MANA POT.
								this.aChar[7] += _root.mana[this.nPotion][1];
								if (this.aChar[7]>this.aChar[8]) {
									this.aChar[7] = this.aChar[8];
								}
								_root.kbsStat.addText("\n"+this.aChar[0]+" regain MP by: "+_root.mana[this.nPotion][1]);
								_root.kbcControl.ColorEffect(0, 0, 200, 20, this.mcChar);
								_root.addFText(this.mcChar._x, this.mcChar._y-50, "+"+_root.mana[this.nPotion][1], 0x0000ff);
							} else {
								//HEALING POT.
								this.aChar[5] += _root.heal[this.nPotion][1];
								if (this.aChar[5]>this.aChar[6]) {
									this.aChar[5] = this.aChar[6];
								}
								_root.kbcControl.ColorEffect(200, 0, 0, 20, this.mcChar);
								_root.kbsStat.addText("\n"+this.aChar[0]+" was healed for: "+_root.heal[this.nPotion][1]);
								_root.addFText(this.mcChar._x, this.mcChar._y-50, "+"+_root.heal[this.nPotion][1], 0xff0000);
							}
						} else {
							//Monster heal
							this.aChar[5] += Math.floor(this.aChar[6]/4);
							if (this.aChar[5]>this.aChar[6]) {
								this.aChar[5] = this.aChar[6];
							}
							// Mana cost
							this.aChar[7] -= 10;
							//
							_root.kbcControl.ColorEffect(200, 0, 0, 20, this.mcChar);
							_root.kbsStat.addText("\n"+this.aChar[0]+" was healed for: "+(this.aChar[6]/4));
							_root.addFText(this.mcChar._x, this.mcChar._y-50, "+"+(this.aChar[6]/4), 0xff0000);
						}
					}
					if (_root.usePotionAnim) {
						this.mcAnim.gotoAndStop(6);
					} else {
						this.bEnd = true;
					}
					break;
				case 5 :
					//run --------------
					if (this.bAlly) {
						_root.kbsStat.addText("\nParty tries to run!");
						this.mcAnim.gotoAndStop(1);
						this.mcAnim._xscale = -100;
						_root.kbsStat.setTimeout(30);
						_root.cMode = -30;
						this.nCooldown = 0;
					} else {
						if(this.mcAnim._totalframes>=8) {
							this.mcAnim.gotoAndStop(8);
							if(this.mcAnim.anim==null) this.mcAnim._visible = false;
						}else this.mcAnim._visible = false;
						
						_root.expToGive -= this.aChar[10];
						_root.cashToGive -= this.aChar[10];
						_root.kbsStat.addText("\n"+this.aChar[0]+" had run away!");
						this.aChar[5] = 0;
						this.mcPointer._visible = false;
						this.mcPointer.onEnterFrame = null;
						this.mcPointer.removeMovieClip();
						this.mcPointer.unloadMovie();
						if (_root.kbcTarget == this) {
							for (var idx in _root.aMons) {
								if (_root.aMons[idx].isAlive()) {
									_root.kbcTarget = _root.aMons[idx];
									break;
								}
							}
						}
						_root.cho = 0;
						_root.cMode = 0;
					}
					break;
				case 6 :
					//SUMMON --------------
					if (this.bAlly) {
						if (!this.bHuman) {
							_root.cho = 1;
							return false;
						}
						if (this.bSummon) {
							_root.cho = 0;
							_root.SMS("You can only summon once per battle", 50);
						} else {
							_root.kbsStat.addText("\n"+this.aChar[0]+" calls a Summon!");
							this.mcAnim.gotoAndStop(7);
							if (this.bHit) {
								//TODO: Summon for player
								//_root.BChar.dmgCTRL.sendATK(this, 7, true, _root.cho);
								//_root.kbsStat.addText("\n"+this.aChar[0]);
							}
						}
					} else {
						//Summon system for enemy
						_root.kbsStat.addText("\n"+this.aChar[0]+" calles for backup!\n");
						_root.summonMonster();
						_root.cho = 0;
						this.nCooldown = 0;
						// Mana cost
						this.aChar[7] -= 20;
						break;
					}
					break;
				default :
					// SKILLS ------------------------------
					// MP checking 
					if (this.aSkill[_root.cho-9][6]<=this.aChar[7]) {
						if (!this.bEnd) {
							this.mcAnim.gotoAndStop(_root.cho);
							if (this.bHit) {
								_root.kbcControl.doDamage(this, this.bHuman ? _root.kbcTarget : this.kbcTarget, this.aSkill[_root.cho-9]);
							}
						} else {
							this.aChar[7] -= this.aSkill[_root.cho-9][6];
						}
					} else {
						//if no mana
						_root.SMS("NOT ENOUGH MANA POINTS!", 20);
						_root.cho = 0;
					}
					// END OF SKILLS --------------------------
				}
				//
				if (this.bEnd) {
					_root.cho = 0;
					this.nCooldown = 0;
					this.mcAnim.gotoAndStop(1);
					if (this.nBerserkTime>0) {
						_root.kbcControl.ColorEffect(200, 0, 0, 50, this.mcChar);
					}
				}
			}
		}
		return false;
	}
	public function cool():Boolean {
		if (this.aChar[5]<=0) {
			return false;
		}
		if (this.nCooldown<100) {
			//0.5 to make it always add something
			if (_root.cho != 0) {
				this.nCooldown += 0.5+Math.floor(Math.sqrt(this.aChar[3]))/30;
			} else {
				this.nCooldown += 0.5+Math.floor(Math.sqrt(this.aChar[3]))/10;
			}
			//
			if (this.nCooldown>100) {
				this.nCooldown = 100;
			}
			if (this.mcCoolBar != null) {
				//Cooldown Bar redraw                   
				this.mcCoolBar.clear();
				this.mcCoolBar.beginFill(0xff0000, 100);
				this.mcCoolBar.moveTo(0, 0);
				this.mcCoolBar.lineTo(this.nCooldown, 0);
				this.mcCoolBar.lineTo(this.nCooldown, 10);
				this.mcCoolBar.lineTo(0, 10);
				this.mcCoolBar.endFill();
				this.mcCoolBar.beginFill(0xff0000, 25);
				this.mcCoolBar.moveTo(this.nCooldown, 0);
				this.mcCoolBar.lineTo(100, 0);
				this.mcCoolBar.lineTo(100, 10);
				this.mcCoolBar.lineTo(this.nCooldown, 10);
				this.mcCoolBar.endFill();
			}
			return false;
		}
		return true;
	}
	public function isCool():Boolean {
		return this.nCooldown>=100;
	}
	public function isAlive():Boolean {
		return this.aChar[5]>0;
	}
	public function dealDamage(type:Number, dmg:Number, maxDmg:Number, caster:KamiBattleChar, target:KamiBattleChar):Number {
		if (this.aChar[5]<=0) return 0;
		
		var bIgnore:Boolean = ( caster == null || target == null || (type!=1 && type!=0) );
		var bNeg:Boolean = dmg<0;
		var nDmg:Number = 0;
		//var s:String = "";
		
		switch(type) {
			case 0:
				// Attack
			case 1:
				// Normal skill
			case 2:
				// Power skill
				if(type==0) nDmg = dmg;
				else {
					nDmg = dmg+random(maxDmg-dmg);
					if(type==2) bIgnore=true;
				}
				//
				// Miss chance and Defence value
				if (!bIgnore) {
					//if ( Math.random()<=(this.aChar[3]-caster.getStat(3))/_root.nMissFactor ) nDmg = 0;
					//else nDmg -= this.aItem[5]/10;
					var tSum:Number = this.aChar[3]+caster.getStat(3);
					if( Math.random()*(this.aChar[3]/tSum) > (Math.random()*(caster.getStat(3)/tSum))+_root.nMissFactor ) nDmg = 0;
					else nDmg -= this.aItem[5]/5;
					// defence stance halfs damage
					if (this.bDef) nDmg = nDmg/2;
				}
				//
				// rounding                         
				nDmg = Math.floor(nDmg);
				if(bNeg) {
					if(nDmg>0) nDmg=0;
				} else {
					if(nDmg<0) nDmg=0;
				}
				//
				// dealing damage
				this.aChar[5] -= nDmg;
				if (this.aChar[5]<0) this.aChar[5] = 0;
				//
				// Message
				if(nDmg==0) {
					if(Math.random()>0.5) _root.playSound("miss",false); else _root.playSound("miss2",false);
					_root.kbcControl.sMessage += " attacked "+this.aChar[0]+" but missed";
					_root.kbcControl.MissEffect(this.mcChar, this.mcAnim, 20, 5);
					_root.addFText(this.mcChar._x, this.mcChar._y-50, "MISS", 0x0088cc);
				} else {
					var tmp:Number = Math.random();
					if(tmp<0.33) {
						_root.playSound("punch3",false);
					}else if(tmp<0.66) {
						_root.playSound("punch2",false);
					}else {
						_root.playSound("punch",false);
					}
					_root.kbcControl.sMessage += " did "+nDmg+" damage to "+this.aChar[0];
					_root.kbcControl.ShakeEffect(5, this.mcChar);
					_root.addFText(this.mcChar._x, this.mcChar._y-50, nDmg, 0x00dd00);
				}
				//
				break;
			case 3:
				// Set on fire
				// Miss chance - SoF can miss!
				// "bIgnor" is set to 'true' when spell type is set to "leech" and caster is now given what he stole
				// it can't miss in that case
				if (!bIgnore) {
					var tSum:Number = this.aChar[3]+caster.getStat(3);
					if( Math.random()*(this.aChar[3]/tSum) > (Math.random()*(caster.getStat(3)/tSum))+_root.nMissFactor ) return 0;
					//if ( Math.random()<=(this.aChar[3]-caster.getStat(3))/_root.nMissFactor ) return 0;
				}
				this.aFire.push([dmg,maxDmg]);
				//
				// dealing damage
				this.nDmg = dmg;
				this.aChar[5] -= this.nDmg;
				if (this.aChar[5]<0) this.aChar[5] = 0;
				//
				_root.playSound("firehit",false);
				_root.kbcControl.sMessage = "\n"+this.aChar[0]+" is on fire! (literally)";
				_root.addFText(this.mcChar._x, this.mcChar._y-50, this.nDmg, 0xffff00);
				_root.kbcControl.ColorEffect(200, 200, 0, 25, this.mcChar);
				//
				break;
			case 4:
				// Berserk
				nDmg = Math.floor(dmg-Math.floor((this.aChar[4]-caster.getStat(4))/2));
				if (nDmg>0) {
					_root.kbcControl.sMessage += " made "+this.aChar[0]+" go berserk!";
					_root.addFText(this.mcChar._x, this.mcChar._y-50, "BERSERK!", 0xee0000);
					_root.kbcControl.ColorEffect(200, 0, 0, 25, this.mcChar);
					this.bBerserk = true;
					this.bBerserkAI = this.bHuman;
					this.bHuman = false;
					this.nBerserkTime = nDmg;
				} else {
					_root.kbcControl.MissEffect(this.mcChar, this.mcAnim, 20, 5);
					_root.kbsStat.addText(" tried to make "+this.aChar[0]+" go berserk but failed");
				}
				break;
			case 5:
				// State Change
				//0."name" 1."Str" 2."Vit" 3."Dex" 4."Int" 5."HP" 6."MaxHP" 7."MP" 8."MaxMP" 9."Atk" 10."Def" 11."Move time"        
				var s:String = "";
				if (maxDmg != 0) {
					_root.playSound("splat",false);
					s = dmg<0 ? " lowered " : " rised ";
					s += this.aChar[0]+"\'s "+_root.kbcControl.aStatName[maxDmg]+" by "+dmg;
					_root.addFText(this.mcChar._x, this.mcChar._y-50, dmg<0 ? ""+dmg : "+"+dmg, 0x990099);
					_root.kbcControl.ColorEffect(200, 0, 200, 20, this.mcChar);
				}
				switch (maxDmg) {
					case 1 :
					case 2 :
					case 3 :
					case 4 :
					case 5 :
					case 6 :
					case 7 :
					case 8 :
						if( this.aChar[maxDmg]<=0) {
							dmg = 0;
						}else {
							if( this.aChar[maxDmg]+dmg<0) {
								dmg = -this.aChar[maxDmg];
							}
						}
						this.aChar[maxDmg] += dmg;
						this.aStatChange[maxDmg] -= dmg;
						break;
					case 9 :
						if( this.aItem[0][1]<=0) {
							dmg = 0;
						}else {
							if( this.aItem[0][1]+dmg<0) {
								dmg = -this.aItem[0][1];
							}
						}
						this.aItem[0][1] += dmg;
						this.aStatChange[maxDmg] -= dmg;
						break;
					case 10 :
						if( this.aItem[5]<=0) {
							dmg = 0;
						}else {
							if( this.aItem[5]+dmg<0) {
								dmg = -this.aItem[5];
							}
						}
						this.aItem[5] += dmg;
						this.aStatChange[maxDmg] -= dmg;
						break;
					case 11:
						dmg = Math.floor(dmg*(caster.getStat(3)/this.aChar[3]));
						this.nCooldown += dmg;
						if (this.nCooldown<0) this.nCooldown = 0;
						else if (this.nCooldown>100) this.nCooldown = 100;
						break;
					default:
						_root.kbsStat.addText("ERROR: wrong Stat Change value");
						break;
				}
				_root.kbcControl.sMessage += s;
				break;
			case 6:
				// Heal
				nDmg = dmg+random(maxDmg-dmg);
				//
				// rounding                         
				//nDmg = Math.floor(nDmg);
				if(bNeg) {
					if(nDmg>0) nDmg=0;
				} else {
					if(nDmg<0) nDmg=0;
				}
				//
				// dealing damage
				this.aChar[5] += nDmg;
				if (this.aChar[5]<0) this.aChar[5] = 0;
				//
				// Message
				_root.kbcControl.sMessage += " healed "+this.aChar[0]+" for "+nDmg;
				_root.addFText(this.mcChar._x, this.mcChar._y-50, nDmg, 0x00ff00);
				_root.kbcControl.ColorEffect(0, 250, 0, 25, this.mcChar);
				//
				break;
		}
		//
		// Alive state
		if (this.checkDead()) {
			if(caster==target) {
				_root.cho = 0;
				this.nCooldown = 0;
			}
		}
		//
		return nDmg;
				
	}
	//
	private function checkDead():Boolean {
		if (this.aChar[5]<=0) {
			this.aChar[5] = 0;
			this.mcPointer._visible = false;
			this.mcPointer.onEnterFrame = null;
			this.mcPointer.removeMovieClip();
			this.mcPointer.unloadMovie();
			this.mcAnim.gotoAndStop(4);
			this.mcCoolBar._visible = false;
			this.nCooldown = 0;
			_root.kbsStat.addText("\n"+this.aChar[0]+" has fainted!");
			//Players target change
			if (!this.bHuman) {
				for (var idx in _root.aMons) {
					if (_root.aMons[idx].isAlive()) {
						_root.kbcTarget = _root.aMons[idx];
						break;
					}
				}
			}
			return true;
		}
		return false;
	}
	/*
	Potions Message Function =================================================
	*/
	/*
	doHeal()
	Used by potions
	*/
	public function doHeal(p:Number):Boolean {
		if (this.aChar[5]<=0) {
			return;
		}
		if (_root.cho == 0 && this.bAlly) {
			_root.heal[p][0]--;
			this.nPotion = p;
			this.nMoveType = 3;
			this.bPotionType = false;
		}
	}
	/*
	doMana()
	Used by potions
	*/
	public function doMana(p:Number):Boolean {
		if (this.aChar[5]<=0) {
			return;
		}
		if (_root.cho == 0 && this.bAlly) {
			_root.mana[p][0]--;
			this.nPotion = p;
			this.nMoveType = 3;
			this.bPotionType = true;
		}
	}
	/*
	Misc. Functions ==========================================================
	*/
	public function resetStat():Void {
		for (var i:Number = 1; i<9; i++) {
			this.aChar[i] += this.aStatChange[i];
		}
		this.aItem[5] += this.aStatChange[10];
	}
	public function removeChar():Void {
		this.mcChar.removeMovieClip();
		this.mcChar.unloadMovie();
		this.mcAnim.removeMovieClip();
		this.mcAnim.unloadMovie();
		this.mcPointer.removeMovieClip();
		this.mcPointer.unloadMovie();
		this.mcCoolBar.removeMovieClip();
		this.mcCoolBar.unloadMovie();
	}
	/*
	Get/Set Functions ========================================================
	*/
	public function getGroup():Array {
		return this.aGroup;
	}
	public function getStat(id:Number):Number {
		if(id==0) return -1;
		return this.aChar[id];
	}
	public function getName():String {
		return this.aChar[0];
	}
	public function getItem(id:Number):Number {
		return this.aItem[id][1];
	}
	public function getChar():MovieClip {
		return this.mcChar;
	}
	public function getID():Number {
		return this.nID;
	}
	public function setAnim(f:Number):Void {
		if (this.aChar[5]>0) this.mcAnim.gotoAndStop(f);
	}
	public function setMove(m:Number):Void {
		this.nMoveType = m;
	}
	public function setAutoTarget():Void {
		_root.kbcTarget = this;
	}
	public function setStat(id:Number, n:Number):Void {
		switch (id) {
		case 0 :
			break;
		case 1 :
		case 2 :
		case 3 :
		case 4 :
		case 5 :
		case 6 :
		case 7 :
		case 8 :
			this.aChar[id] = n;
			break;
		case 9 :
			this.aItem[0][1] = n;
			break;
		case 10 :
			this.aItem[5] = n;
			break;
		case 11 :
			this.nCooldown = n;
			if (this.nCooldown>100) {
				this.nCooldown = 100;
			} else if (this.nCooldown<0) {
				this.nCooldown = 0;
			}
			break;
		case 12 :
			this.nBerserkTime = n;
			break;
		}
	}
}
