﻿class classes.KamiBattleStatus {
	private var bPlayerDead:Boolean = false;
	private var bEnemyDead:Boolean = false;
	private var bGotCurrent:Boolean = false;
	private var nLvlPlayer:Number = 0;
	//
	private var nTimeout:Number = 0;
	//
	private var mcStat:MovieClip = null;
	private var tfStat:TextField = null;
	//
	function KamiBattleStatus() {
		this.mcStat = _root.BInter.attachMovie("Battle_Status", "stat", _root.BInter.getNextHighestDepth());
		this.mcStat._x = _root.swidth-this.mcStat._width-5;
		this.mcStat._y = _root.sheight-this.mcStat._height-5;
		this.mcStat.gotoAndStop(1);
		this.mcStat.onEnterFrame = function():Void  {
			if(!_root.BInter._visible) return;
			_root.kbsStat.process();
		};
		//
		this.tfStat = this.mcStat.createTextField("subtext", this.mcStat.getNextHighestDepth(), 0, 0, this.mcStat._width, this.mcStat._height);
		this.tfStat.selectable = false;
		this.tfStat.multiline = true;
		this.tfStat.embedFonts = true;
		this.tfStat.wordWrap = true;
		var nTmp:Number = _root.format.size;
		var bTmp:Number = _root.format.bold;
		_root.format.size = 10;
		_root.format.bold = false;
		this.tfStat.setTextFormat(_root.format);
		this.tfStat.setNewTextFormat(_root.format);
		_root.format.size = nTmp;
		_root.format.bold = nTmp;
	}
	public function process():Void {
		//Round loop----------------------------------------------------   
		this.bPlayerDead = true;
		this.bEnemyDead = true;
		if (_root.cMode>=0) {
			// Debug
			//_root.SMS("m1: "+_root.mon1[5]+" m2: "+_root.mon2[5]+" m3: "+_root.mon3[5],2);
			//Characters
			_root.showCommandMenu(false);
			if (_root.cho == 0) {
				_root.kbcCurrent = null;
				for (var ind:Number = 0; ind<_root.aMons.length; ind++) {
					if (_root.aMons[ind].cool()) {
						_root.aMons[ind].process();
						if (_root.cho != 0) {
							_root.kbcCurrent = _root.aMons[ind];
							break;
						}
					}
				}
				if (_root.kbcCurrent == null) {
					this.bGotCurrent = false;
					//_root.kbcPrioPlayer = null;
					_root.kbcCurrentPlayer = null;
					for (var ind:Number = 0; ind<_root.aPlayers.length; ind++) {
						if (_root.aPlayers[ind].cool()) {
							if (_root.charSelect == _root.aPlayers[ind].getID()) {
								_root.kbcPrioPlayer = _root.aPlayers[ind];
								this.bGotCurrent = false;
							}
							//   
							if (_root.aPlayers[ind].process(this.bGotCurrent)) {
								_root.kbcCurrentPlayer = _root.aPlayers[ind];
								this.bGotCurrent = true;
							}
							// 
							if (_root.cho != 0) {
								_root.kbcCurrent = _root.aPlayers[ind];
								break;
							}
						} else {
							if (_root.charSelect == _root.aPlayers[ind].getID()) {
								_root.kbcPrioPlayer = null;
							}
						}
					}
					if (_root.kbcCurrent == null) {
						if (Key.isDown(Key.SPACE)) {
							if (_root.kbcPrioPlayer != null) {
								_root.kbcPrioPlayer.setMove(1);
							} else {
								_root.kbcCurrentPlayer.setMove(1);
							}
						}
					}
				}
			} else {
				_root.kbcCurrent.process();
				for (var ind:Number = 0; ind<_root.aChars.length; ind++) {
					_root.aChars[ind].cool();
				}
			}
			// Again cho == 0
			// Because it can change in above statement
			if (_root.cho == 0) {
				for (var j:Number = 1; j<=_root.playersCount; j++) {
					if (_root.aPlayerTeam[j][0][5]>0 && _root.aPlayerTeam[j][0][5] != null) {
						this.bPlayerDead = false;
					}
				}
				for (var j:Number = 1; j<=_root.monstersCount; j++) {
					if (_root.aEnemyTeam[j][0][5]>0 && _root.aEnemyTeam[j][0][5] != null) {
						this.bEnemyDead = false;
					}
				}
				if (this.bEnemyDead) {
					if ( _root.cMode>-10 ) {
						//trace("m1: "+_root.mon1[5]+" m2: "+_root.mon2[5]+" m3: "+_root.mon3[5]);
						//PARTY WON
						_root.showCommandMenu(false);
						_root.cMode = -21;
						this.nLvlPlayer = 1;
						this.nTimeout = 60;
						//reseting any modified stats and forcing victory pose
						for (var i:Number = 0; i<=_root.aPlayers.length; i++) {
							_root.aPlayers[i].resetStat();
							_root.aPlayers[i].setAnim(2);
						}
						//CASH AND EXP CALCULATING!
						for (var i:Number = 1; i<=_root.playersCount; i++) {
							if (_root.aPlayerTeam[i][0][11] != null) {
								_root.expToGive = Math.floor(_root.expToGive/_root.aPlayerTeam[i][0][11]);
								break;
							}
						}
						//After battle time 
						this.addText("\nPlayer wins!");
						this.addText("\nPlayer earned: "+_root.cashToGive+" $");
						_root.addCash(_root.cashToGive);
						_root.cashToGive = 0;
					}
				} else if (this.bPlayerDead) {
					if (_root.cMode>-10 ) {
						//PARTY FAILED
						_root.showCommandMenu(false);
						_root.cMode = -10;
						this.nTimeout = 60;
						//reseting any modified stats and forcing victory pose for enemies
						for (var idx in _root.aPlayers) {
							_root.aPlayers[idx].resetStat();
						}
						for (var idx in _root.aMons) {
							_root.aMons[idx].setAnim(2);
						}
						//After battle time   
						this.addText("\nParty has been defeated!");
					}
				}
			}
		} else {
			switch (_root.cMode) {
			case -10 :
				//Player Lost
				if (this.nTimeout>0) {
					this.nTimeout--;
				} else {
					for (var i:Number = 1; i<=_root.playersCount; i++) {
						if (_root.aPlayerTeam[i][0][5] != null) {
							_root.aPlayerTeam[i][0][5] = 1;
						}
					}
					_root.cMode = -50;
					_root.kbcCurrent = null;
					_root.kbcCurrentPlayer = null;
					_root.kbcPrioPlayer = null;
					_root.kbcTarget = null;
					_root.aChars = new Array();
					_root.aPlayers = new Array();
					_root.aMons = new Array();
					_root.BInter._visible = false;
					//FADE EFFECT along with battle quiting
					_root.fade(0, 1, 10, _root.fightExitLost);
					//
				}
				break;
			case -11 :
				//Player Won or Run away
				if (this.nTimeout>0) {
					this.nTimeout--;
				} else {
					_root.cMode = -50;
					_root.kbcCurrent = null;
					_root.kbcCurrentPlayer = null;
					_root.kbcPrioPlayer = null;
					_root.kbcTarget = null;
					_root.aChars = new Array();
					_root.aPlayers = new Array();
					_root.aMons = new Array();
					_root.BInter._visible = false;
					//FADE EFFECT along with battle quiting
					_root.fade(0, 1, 10, _root.fightExitWon);
					//
				}
				break;
			case -21 :
				//Levelup window
				if( !_root.kbuSum.isVisible() ) {
					if( this.nLvlPlayer>_root.playersCount) {
						_root.cMode = -11;
						break;
					}
					if (_root.aPlayerTeam[this.nLvlPlayer][0][9] != null && _root.aPlayerTeam[this.nLvlPlayer][0][5]>0) {
						_root.aPlayerTeam[this.nLvlPlayer][0][9] += _root.expToGive;
						if (_root.aPlayerTeam[this.nLvlPlayer][0][9]>=_root.aPlayerTeam[this.nLvlPlayer][0][10]) {
							this.addText("\n"+_root.aPlayerTeam[this.nLvlPlayer][0][0]+" levels up!");
							_root.aPlayerTeam[this.nLvlPlayer][0][5] = _root.aPlayerTeam[this.nLvlPlayer][0][6];
							_root.aPlayerTeam[this.nLvlPlayer][0][7] = _root.aPlayerTeam[this.nLvlPlayer][0][8];
							_root.aPlayerTeam[this.nLvlPlayer][0][11]++;
							_root.aPlayerTeam[this.nLvlPlayer][0][9] = 0;
							_root.aPlayerTeam[this.nLvlPlayer][0][10] = Math.floor(_root.aPlayerTeam[this.nLvlPlayer][0][10]+(_root.aPlayerTeam[this.nLvlPlayer][0][10]/10));
							_root.aPlayerTeam[this.nLvlPlayer][0][13](_root.aPlayerTeam[this.nLvlPlayer][0],_root.aPlayerTeam[this.nLvlPlayer][1],_root.aPlayerTeam[this.nLvlPlayer][2]);
							_root.doLevelUp(_root.aPlayerTeam[this.nLvlPlayer][0],5);
							this.nTimeout = 0;
						}
					}
					this.nLvlPlayer++;
				}
				break;
			case -30 :
				if (this.nTimeout>0) {
					this.nTimeout--;
				} else {
					//RUNNING AWAY FROM BATTLE
					var tchar:Number = 0;
					var tmon:Number = 0;
					//summing players and enemys dex
					for (var i:Number = 1; i<=_root.playersCount; i++) {
						if (_root.aPlayerTeam[i][0][3] != null) {
							tchar += _root.aPlayerTeam[i][0][3];
						}
					}
					for (var i:Number = 1; i<=_root.monstersCount; i++) {
						if (_root.aEnemyTeam[i][0][3] != null) {
							tmon += _root.aEnemyTeam[i][0][3];
						}
					}
					//chances calculating            
					tchar = (tchar/3)*Math.random();
					tmon = (tmon/3)*Math.random();
					//trace(""+tchar+" : "+tmon);
					if (tchar>=tmon) {
						for (var idx in _root.aPlayers) {
							_root.aPlayers[idx].resetStat();
							_root.aPlayers[idx].setAnim(8);
						}
						this.addText("\nPlayer runs away!");
						this.nTimeout = 30;
						_root.cMode = -11;
					} else {
						this.addText("\nPlayer failed to run!");
						_root.cho = 0;
						_root.cMode = 0;
					}
				}
				break;
			case -100 :
				_root.SMS("Loading\n"+_root.readLoad+"/"+_root.toLoad, 3);
				if (_root.toLoad == _root.readLoad) {
					var tchar:Number = 0;
					for (var idx in _root.aChars) {
						tchar += _root.aChars[idx].getStat(3);
					}
					//trace("len:"+_root.aChars.length);
					for (var idx in _root.aChars) {
						_root.aChars[idx].setStat(11, Math.floor(_root.aChars[idx].getStat(3)-(tchar/(_root.aChars.length)))*5);
					}
					_root.cMode = 0;
				}
				break;
			}
		}
	}
	public function addText(s:String):Void {
		this.tfStat.text += s;
		this.tfStat.maxscroll = this.tfStat.length;
		this.tfStat.scroll = this.tfStat.length;
	}
	public function clearText():Void {
		this.tfStat.text = "";
		this.tfStat.maxscroll = 0;
		this.tfStat.scroll = 0;
	}
	public function setTimeout(n:Number):Void {
		this.nTimeout = n;
	}
}
